<?php
global $otwPluginDevName;

$otw_bmp_name = 'otw-bmp';
$otwPluginDevName = 'otw_bmp';
$optionName = $otwPluginDevName . '_list';
$shortcodeName = $otw_bmp_name;
$buttonTypes = array(
    'button-builder' => array(
        'id' => 'button_builder',
        'page_title' => esc_html__('Add Button Builder', 'otw_bmp' ),
        'menu_title' => esc_html__('Add Button Builder', 'otw_bmp' ),
        'title' => esc_html__('Button Builder', 'otw_bmp' ),
        'classes' => array(),
        'default_classes' => array('otw-bmp-button', 'otw-bmp-button-builder'),
        'icon_classes' => array('fa', 'fa-download'),
        'css_files' => array(
            'otw-bmp-button' => 'otw-bmp-button.css',
        ),
        'custom_style_option' => array(

        ),
    ),
    'download-button' => array(
        'id' => 'download_button',
        'page_title' => esc_html__('Add Download Button', 'otw_bmp' ),
        'menu_title' => esc_html__('Add Download Button', 'otw_bmp' ),
        'upper_text' => esc_html__('Upper text', 'otw_bmp' ),
        'title' => esc_html__('Download Button', 'otw_bmp' ),
        'sub_title' => esc_html__('Lower text', 'otw_bmp' ),
        'classes' => array(),
        'default_classes' => array('otw-bmp-button', 'otw-bmp-button-download'),
        'icon_classes' => array('fa', 'fa-download'),
        'css_files' => array(
            'otw-bmp-button' => 'otw-bmp-button.css',
            'otw-bmp-download-button' => 'otw-bmp-download-button.css',
        ),
        'custom_style_option' => array(
            '' => 'none',
            'otw-bmp-download-style-1' => 'style-1',
            'otw-bmp-download-style-2' => 'style-2',
            'otw-bmp-download-style-3' => 'style-3',
        ),
    ),
);

$chosenButtonType = false;
$chosenNewButtonType = false;
if ( otw_get( 'page', false )  &&  otw_get( 'button-type', false ) ) {
    $chosenButtonType = otw_get( 'button-type', '' );
} else if ( otw_get( 'page', false )  &&  otw_post( 'type', false ) ) {
    $chosenButtonType = otw_post( 'type', '' );
} else if ( otw_post( 'type', false ) ) {
    $chosenNewButtonType = otw_post( 'type', '' );
}

$content = array(
    'button_name' => '',
    'type' => '',
    'button_upper_text' => esc_html__('Upper text', 'otw_bmp' ),
    'button_title' => esc_html__('Button', 'otw_bmp' ),
    'sub_button_title' => esc_html__('Subtitle', 'otw_bmp' ),
    'button_parent_class' => '',
    'button_parent_style' => array(
        'font-family' => '',
        'margin-top' => 0,
        'margin-left' => 0,
        'margin-right' => 0,
        'margin-bottom' => 0,
    ),
    'button_hover_style' => array(
        'opacity' => 1,
    ),
    'button_class' => '',
    'button_icon' => '',
    'icon_url' => '',
    'button_background' => array(
        'background-color' => '#ffffff',
    ),
    'button_style' => array(
        'font-size' => 14,
        'color' => '#000000',
        'border-color' => '#000000',
        'padding-top' => 10,
        'padding-left' => 10,
        'padding-right' => 10,
        'padding-bottom' => 10,
        'border-style' => 'solid',
        'border-width' => 1,
        'border-radius' => 4,
    ),
    'sub_button_style' => array(
        'font-size' => 10,
        'color' => '#000000',
        'background-color' => '#000000',
        'border-color' => '#000000',
        'margin-top' => 0,
        'margin-left' => 0,
        'margin-right' => 0,
        'margin-bottom' => 0,
        'padding-top' => 10,
        'padding-left' => 10,
        'padding-right' => 10,
        'padding-bottom' => 10,
        'border-style' => 'solid',
        'border-width' => 1,
        'border-radius' => 4,
        'text-align' => 'left'
    ),
    'upper_button_style' => array(
        'font-size' => 10,
        'color' => '#ffffff',
        'background-color' => '#000000',
        'border-color' => '#000000',
        'margin-top' => 0,
        'margin-left' => 0,
        'margin-right' => 0,
        'margin-bottom' => 0,
        'padding-top' => 10,
        'padding-left' => 10,
        'padding-right' => 10,
        'padding-bottom' => 10,
        'border-style' => 'solid',
        'border-width' => 1,
        'border-radius' => 4,
        'text-align' => 'left'
    ),
    'button_icon_box' => array(
        'background-color' => 'inherit',
        'border-color' => 'none',
        'padding-top' => 10,
        'padding-left' => 10,
        'padding-right' => 10,
        'padding-bottom' => 10,
        'margin-top' => 0,
        'margin-left' => 0,
        'margin-right' => 0,
        'margin-bottom' => 0,
        'border-style' => 'none',
        'border-width' => 1,
        'border-radius' => 4,
    ),
);

if ($chosenNewButtonType === 'button-builder'){
    $content['button_hover_style']['opacity'] = 0.6;
    
} else if ($chosenNewButtonType === 'download-button'){

    $content['button_icon'] = 'fa-download';
    $content['sub_button_style']['color'] = '#FFFFFF';
    $content['button_style']['border-radius'] = 0;
}

$linkTargetOptions = array(
    '_self' => esc_html__('Same Window / Tab (default)', 'otw_bmp' ),
    '_blank' => esc_html__('New Window / Tab', 'otw_bmp' ),
);

$fontsArray = array();
require_once(dirname(__FILE__) . DIRECTORY_SEPARATOR . 'fonts.php');
$fontsArray = json_decode($allFonts);

$webSafeFonts = array(
    '' => esc_html__('inherit (default)', 'otw_bmp' ),
    'Arial, Helvetica, sans-serif' => 'Arial, Helvetica, sans-serif',
    'Arial Black, Gadget, sans-serif' => 'Arial Black, Gadget, sans-serif',
    'Comic Sans MS, cursive, sans-serif' => 'Comic Sans MS, cursive, sans-serif',
    'Lucida Sans Unicode, Lucida Grande, sans-serif' => 'Lucida Sans Unicode, Lucida Grande, sans-serif',
    'Tahoma, Geneva, sans-serif' => 'Tahoma, Geneva, sans-serif',
    'Trebuchet MS, Helvetica, sans-serif' => 'Trebuchet MS, Helvetica, sans-serif',
    'Verdana, Geneva, sans-serif' => 'Verdana, Geneva, sans-serif',
    'Courier New, Courier, monospace' => 'Courier New, Courier, monospace',
    'Lucida Console, Monaco, monospace' => 'Lucida Console, Monaco, monospace',
);

if (!empty($fontsArray)) {
    $webSafeFonts = array();
    foreach ($fontsArray as $font) {
        $webSafeFonts[''] = esc_html__('inherit (default)', 'otw_bmp' );
        $webSafeFonts[$font->text] = $font->text;
    }
}

$otwAnimationsList = array(
    '' => 'none',
    "hvr-grow" => esc_html__("Grow", 'otw_bmp' ),
    "hvr-shrink" => esc_html__("Shrink", 'otw_bmp' ),
    "hvr-pulse" => esc_html__("Pulse", 'otw_bmp' ),
    "hvr-push" => esc_html__("Push", 'otw_bmp' ),
    "hvr-pop" => esc_html__("Pop", 'otw_bmp' ),
    "hvr-rotate" => esc_html__("Rotate", 'otw_bmp' ),
    "hvr-float" => esc_html__("Float", 'otw_bmp' ),
    "hvr-sink" => esc_html__("Sink", 'otw_bmp' ),
    "hvr-bob" => esc_html__("Bob", 'otw_bmp' ),
    "hvr-hang" => esc_html__("Hang", 'otw_bmp' ),
    "hvr-skew" => esc_html__("Skew", 'otw_bmp' ),
    "hvr-buzz" => esc_html__("Buzz", 'otw_bmp' ),
    "hvr-forward" => esc_html__("Forward", 'otw_bmp' ),
    "hvr-backward" => esc_html__("Backward", 'otw_bmp' ),
    "hvr-fade" => esc_html__("Fade", 'otw_bmp' ),
    "hvr-hollow" => esc_html__("Hollow", 'otw_bmp' ),
    "hvr-trim" => esc_html__("Trim", 'otw_bmp' ),
    "hvr-reveal" => esc_html__("Reveal", 'otw_bmp' ),
    "hvr-glow" => esc_html__("Glow", 'otw_bmp' ),
    "hvr-shadow" => esc_html__("Shadow", 'otw_bmp' ),
    "hvr-pulse-grow" => esc_html__("Pulsegrow", 'otw_bmp' ),
    "hvr-pulse-shrink" => esc_html__("Pulseshrink", 'otw_bmp' ),
    "hvr-grow-rotate" => esc_html__("Growrotate", 'otw_bmp' ),
    "hvr-skew-forward" => esc_html__("Skewforward", 'otw_bmp' ),
    "hvr-skew-backward" => esc_html__("Skewbackward", 'otw_bmp' ),
    "hvr-wobble-vertical" => esc_html__("Wobblevertical", 'otw_bmp' ),
    "hvr-wobble-horizontal" => esc_html__("Wobblehorizontal", 'otw_bmp' ),
    "hvr-wobble-top" => esc_html__("Wobbletop", 'otw_bmp' ),
    "hvr-wobble-bottom" => esc_html__("Wobblebottom", 'otw_bmp' ),
    "hvr-wobble-skew" => esc_html__("Wobbleskew", 'otw_bmp' ),
    "hvr-buzz-out" => esc_html__("Buzzout", 'otw_bmp' ),
    "hvr-radial-out" => esc_html__("Radialout", 'otw_bmp' ),
    "hvr-radial-in" => esc_html__("Radialin", 'otw_bmp' ),
    "hvr-rectangle-in" => esc_html__("Rectanglein", 'otw_bmp' ),
    "hvr-rectangle-out" => esc_html__("Rectangleout", 'otw_bmp' ),
    "hvr-ripple-out" => esc_html__("Rippleout", 'otw_bmp' ),
    "hvr-ripple-in" => esc_html__("Ripplein", 'otw_bmp' ),
    "hvr-outline-out" => esc_html__("Outlineout", 'otw_bmp' ),
    "hvr-outline-in" => esc_html__("Outlinein", 'otw_bmp' ),
    "hvr-round-corners" => esc_html__("Roundcorners", 'otw_bmp' ),
    "hvr-underline-reveal" => esc_html__("Underlinereveal", 'otw_bmp' ),
    "hvr-overline-reveal" => esc_html__("Overlinereveal", 'otw_bmp' ),
    "hvr-grow-shadow" => esc_html__("Growshadow", 'otw_bmp' ),
    "hvr-float-shadow" => esc_html__("Floatshadow", 'otw_bmp' ),
    "hvr-shadow-radial" => esc_html__("Shadowradial", 'otw_bmp' ),
    "hvr-bubble-top" => esc_html__("Bubbletop", 'otw_bmp' ),
    "hvr-bubble-right" => esc_html__("Bubbleright", 'otw_bmp' ),
    "hvr-bubble-bottom" => esc_html__("Bubblebottom", 'otw_bmp' ),
    "hvr-bubble-left" => esc_html__("Bubbleleft", 'otw_bmp' ),
    "hvr-icon-back" => esc_html__("Iconback", 'otw_bmp' ),
    "hvr-icon-forward" => esc_html__("Iconforward", 'otw_bmp' ),
    "hvr-icon-down" => esc_html__("Icondown", 'otw_bmp' ),
    "hvr-icon-up" => esc_html__("Iconup", 'otw_bmp' ),
    "hvr-icon-spin" => esc_html__("Iconspin", 'otw_bmp' ),
    "hvr-icon-drop" => esc_html__("Icondrop", 'otw_bmp' ),
    "hvr-icon-fade" => esc_html__("Iconfade", 'otw_bmp' ),
    "hvr-icon-grow" => esc_html__("Icongrow", 'otw_bmp' ),
    "hvr-icon-shrink" => esc_html__("Iconshrink", 'otw_bmp' ),
    "hvr-icon-pulse" => esc_html__("Iconpulse", 'otw_bmp' ),
    "hvr-icon-push" => esc_html__("Iconpush", 'otw_bmp' ),
    "hvr-icon-pop" => esc_html__("Iconpop", 'otw_bmp' ),
    "hvr-icon-bounce" => esc_html__("Iconbounce", 'otw_bmp' ),
    "hvr-icon-rotate" => esc_html__("Iconrotate", 'otw_bmp' ),
    "hvr-icon-float" => esc_html__("Iconfloat", 'otw_bmp' ),
    "hvr-icon-sink" => esc_html__("Iconsink", 'otw_bmp' ),
    "hvr-icon-bob" => esc_html__("Iconbob", 'otw_bmp' ),
    "hvr-icon-hang" => esc_html__("Iconhang", 'otw_bmp' ),
    "hvr-icon-buzz" => esc_html__("Iconbuzz", 'otw_bmp' ),
    "hvr-sweep-to-right" => esc_html__("Sweeptoright", 'otw_bmp' ),
    "hvr-sweep-to-left" => esc_html__("Sweeptoleft", 'otw_bmp' ),
    "hvr-sweep-to-bottom" => esc_html__("Sweeptobottom", 'otw_bmp' ),
    "hvr-sweep-to-top" => esc_html__("Sweeptotop", 'otw_bmp' ),
    "hvr-bounce-to-right" => esc_html__("Bouncetoright", 'otw_bmp' ),
    "hvr-bounce-to-left" => esc_html__("Bouncetoleft", 'otw_bmp' ),
    "hvr-bounce-to-bottom" => esc_html__("Bouncetobottom", 'otw_bmp' ),
    "hvr-bounce-to-top" => esc_html__("Bouncetotop", 'otw_bmp' ),
    "hvr-shutter-in-horizontal" => esc_html__("Shutterinhorizontal", 'otw_bmp' ),
    "hvr-shutter-out-horizontal" => esc_html__("Shutterouthorizontal", 'otw_bmp' ),
    "hvr-shutter-in-vertical" => esc_html__("Shutterinvertical", 'otw_bmp' ),
    "hvr-shutter-out-vertical" => esc_html__("Shutteroutvertical", 'otw_bmp' ),
    "hvr-underline-from-left" => esc_html__("Underlinefromleft", 'otw_bmp' ),
    "hvr-underline-from-center" => esc_html__("Underlinefromcenter", 'otw_bmp' ),
    "hvr-underline-from-right" => esc_html__("Underlinefromright", 'otw_bmp' ),
    "hvr-overline-from-left" => esc_html__("Overlinefromleft", 'otw_bmp' ),
    "hvr-overline-from-center" => esc_html__("Overlinefromcenter", 'otw_bmp' ),
    "hvr-overline-from-right" => esc_html__("Overlinefromright", 'otw_bmp' ),
    "hvr-box-shadow-outset" => esc_html__("Boxshadowoutset", 'otw_bmp' ),
    "hvr-box-shadow-inset" => esc_html__("Boxshadowinset", 'otw_bmp' ),
    "hvr-bubble-float-top" => esc_html__("Bubblefloattop", 'otw_bmp' ),
    "hvr-bubble-float-right" => esc_html__("Bubblefloatright", 'otw_bmp' ),
    "hvr-bubble-float-bottom" => esc_html__("Bubblefloatbottom", 'otw_bmp' ),
    "hvr-bubble-float-left" => esc_html__("Bubblefloatleft", 'otw_bmp' ),
    "hvr-icon-float-away" => esc_html__("Iconfloataway", 'otw_bmp' ),
    "hvr-icon-sink-away" => esc_html__("Iconsinkaway", 'otw_bmp' ),
    "hvr-icon-pulse-grow" => esc_html__("Iconpulsegrow", 'otw_bmp' ),
    "hvr-icon-pulse-shrink" => esc_html__("Iconpulseshrink", 'otw_bmp' ),
    "hvr-icon-grow-rotate" => esc_html__("Icongrowrotate", 'otw_bmp' ),
    "hvr-icon-wobble-horizontal" => esc_html__("Iconwobblehorizontal", 'otw_bmp' ),
    "hvr-icon-wobble-vertical" => esc_html__("Iconwobblevertical", 'otw_bmp' ),
    "hvr-icon-buzz-out" => esc_html__("Iconbuzzout", 'otw_bmp' ),
    "hvr-curl-top-left" => esc_html__("Curltopleft", 'otw_bmp' ),
    "hvr-curl-top-right" => esc_html__("Curltopright", 'otw_bmp' ),
    "hvr-curl-bottom-right" => esc_html__("Curlbottomright", 'otw_bmp' ),
    "hvr-curl-bottom-left" => esc_html__("Curlbottomleft", 'otw_bmp' ),
    "hvr-wobble-to-bottom-right" => esc_html__("Wobbletobottomright", 'otw_bmp' ),
    "hvr-wobble-to-top-right" => esc_html__("Wobbletotopright", 'otw_bmp' ),
);

$borderStyleOptions = array(
    'none' => 'none',
    'dotted' => 'dotted',
    'dashed' => 'dashed',
    'solid' => 'solid',
    'double' => 'double',
    'groove' => 'groove',
    'ridge' => 'ridge',
    'inset' => 'inset',
    'outset' => 'outset',
    'hidden' => 'hidden',
    'dotted dashed solid double' => 'dotted dashed solid double',
);

$iconOptions = array(
    '' => '---',
    "fa-glass" => "glass",
    "fa-music" => "music",
    "fa-search" => "search",
    "fa-envelope-o" => "envelope o",
    "fa-heart" => "heart",
    "fa-star" => "star",
    "fa-star-o" => "star o",
    "fa-user" => "user",
    "fa-film" => "film",
    "fa-th-large" => "th large",
    "fa-th" => "th",
    "fa-th-list" => "th list",
    "fa-check" => "check",
    "fa-remove" => "remove",
    "fa-search-plus" => "search plus",
    "fa-search-minus" => "search minus",
    "fa-power-off" => "power off",
    "fa-signal" => "signal",
    "fa-gear" => "gear",
    "fa-trash-o" => "trash o",
    "fa-home" => "home",
    "fa-file-o" => "file o",
    "fa-clock-o" => "clock o",
    "fa-road" => "road",
    "fa-download" => "download",
    "fa-arrow-circle-o-down" => "arrow circle o down",
    "fa-arrow-circle-o-up" => "arrow circle o up",
    "fa-inbox" => "inbox",
    "fa-play-circle-o" => "play circle o",
    "fa-rotate-right" => "rotate right",
    "fa-refresh" => "refresh",
    "fa-list-alt" => "list alt",
    "fa-lock" => "lock",
    "fa-flag" => "flag",
    "fa-headphones" => "headphones",
    "fa-volume-off" => "volume off",
    "fa-volume-down" => "volume down",
    "fa-volume-up" => "volume up",
    "fa-qrcode" => "qrcode",
    "fa-barcode" => "barcode",
    "fa-tag" => "tag",
    "fa-tags" => "tags",
    "fa-book" => "book",
    "fa-bookmark" => "bookmark",
    "fa-print" => "print",
    "fa-camera" => "camera",
    "fa-font" => "font",
    "fa-bold" => "bold",
    "fa-italic" => "italic",
    "fa-text-height" => "text height",
    "fa-text-width" => "text width",
    "fa-align-left" => "align left",
    "fa-align-center" => "align center",
    "fa-align-right" => "align right",
    "fa-align-justify" => "align justify",
    "fa-list" => "list",
    "fa-dedent" => "dedent",
    "fa-indent" => "indent",
    "fa-video-camera" => "video camera",
    "fa-photo" => "photo",
    "fa-pencil" => "pencil",
    "fa-map-marker" => "map marker",
    "fa-adjust" => "adjust",
    "fa-tint" => "tint",
    "fa-edit" => "edit",
    "fa-share-square-o" => "share square o",
    "fa-check-square-o" => "check square o",
    "fa-arrows" => "arrows",
    "fa-step-backward" => "step backward",
    "fa-fast-backward" => "fast backward",
    "fa-backward" => "backward",
    "fa-play" => "play",
    "fa-pause" => "pause",
    "fa-stop" => "stop",
    "fa-forward" => "forward",
    "fa-fast-forward" => "fast forward",
    "fa-step-forward" => "step forward",
    "fa-eject" => "eject",
    "fa-chevron-left" => "chevron left",
    "fa-chevron-right" => "chevron right",
    "fa-plus-circle" => "plus circle",
    "fa-minus-circle" => "minus circle",
    "fa-times-circle" => "times circle",
    "fa-check-circle" => "check circle",
    "fa-question-circle" => "question circle",
    "fa-info-circle" => "info circle",
    "fa-crosshairs" => "crosshairs",
    "fa-times-circle-o" => "times circle o",
    "fa-check-circle-o" => "check circle o",
    "fa-ban" => "ban",
    "fa-arrow-left" => "arrow left",
    "fa-arrow-right" => "arrow right",
    "fa-arrow-up" => "arrow up",
    "fa-arrow-down" => "arrow down",
    "fa-mail-forward" => "mail forward",
    "fa-expand" => "expand",
    "fa-compress" => "compress",
    "fa-plus" => "plus",
    "fa-minus" => "minus",
    "fa-asterisk" => "asterisk",
    "fa-exclamation-circle" => "exclamation circle",
    "fa-gift" => "gift",
    "fa-leaf" => "leaf",
    "fa-fire" => "fire",
    "fa-eye" => "eye",
    "fa-eye-slash" => "eye slash",
    "fa-warning" => "warning",
    "fa-plane" => "plane",
    "fa-calendar" => "calendar",
    "fa-random" => "random",
    "fa-comment" => "comment",
    "fa-magnet" => "magnet",
    "fa-chevron-up" => "chevron up",
    "fa-chevron-down" => "chevron down",
    "fa-retweet" => "retweet",
    "fa-shopping-cart" => "shopping cart",
    "fa-folder" => "folder",
    "fa-folder-open" => "folder open",
    "fa-arrows-v" => "arrows v",
    "fa-arrows-h" => "arrows h",
    "fa-bar-chart-o" => "bar chart o",
    "fa-twitter-square" => "twitter square",
    "fa-facebook-square" => "facebook square",
    "fa-camera-retro" => "camera retro",
    "fa-key" => "key",
    "fa-gears" => "gears",
    "fa-comments" => "comments",
    "fa-thumbs-o-up" => "thumbs o up",
    "fa-thumbs-o-down" => "thumbs o down",
    "fa-star-half" => "star half",
    "fa-heart-o" => "heart o",
    "fa-sign-out" => "sign out",
    "fa-linkedin-square" => "linkedin square",
    "fa-thumb-tack" => "thumb tack",
    "fa-external-link" => "external link",
    "fa-sign-in" => "sign in",
    "fa-trophy" => "trophy",
    "fa-github-square" => "github square",
    "fa-upload" => "upload",
    "fa-lemon-o" => "lemon o",
    "fa-phone" => "phone",
    "fa-square-o" => "square o",
    "fa-bookmark-o" => "bookmark o",
    "fa-phone-square" => "phone square",
    "fa-twitter" => "twitter",
    "fa-facebook-f" => "facebook f",
    "fa-github" => "github",
    "fa-unlock" => "unlock",
    "fa-credit-card" => "credit card",
    "fa-feed" => "feed",
    "fa-hdd-o" => "hdd o",
    "fa-bullhorn" => "bullhorn",
    "fa-bell" => "bell",
    "fa-certificate" => "certificate",
    "fa-hand-o-right" => "hand o right",
    "fa-hand-o-left" => "hand o left",
    "fa-hand-o-up" => "hand o up",
    "fa-hand-o-down" => "hand o down",
    "fa-arrow-circle-left" => "arrow circle left",
    "fa-arrow-circle-right" => "arrow circle right",
    "fa-arrow-circle-up" => "arrow circle up",
    "fa-arrow-circle-down" => "arrow circle down",
    "fa-globe" => "globe",
    "fa-wrench" => "wrench",
    "fa-tasks" => "tasks",
    "fa-filter" => "filter",
    "fa-briefcase" => "briefcase",
    "fa-arrows-alt" => "arrows alt",
    "fa-group" => "group",
    "fa-chain" => "chain",
    "fa-cloud" => "cloud",
    "fa-flask" => "flask",
    "fa-cut" => "cut",
    "fa-copy" => "copy",
    "fa-paperclip" => "paperclip",
    "fa-save" => "save",
    "fa-square" => "square",
    "fa-navicon" => "navicon",
    "fa-list-ul" => "list ul",
    "fa-list-ol" => "list ol",
    "fa-strikethrough" => "strikethrough",
    "fa-underline" => "underline",
    "fa-table" => "table",
    "fa-magic" => "magic",
    "fa-truck" => "truck",
    "fa-pinterest" => "pinterest",
    "fa-pinterest-square" => "pinterest square",
    "fa-google-plus-square" => "google plus square",
    "fa-google-plus" => "google plus",
    "fa-money" => "money",
    "fa-caret-down" => "caret down",
    "fa-caret-up" => "caret up",
    "fa-caret-left" => "caret left",
    "fa-caret-right" => "caret right",
    "fa-columns" => "columns",
    "fa-unsorted" => "unsorted",
    "fa-sort-down" => "sort down",
    "fa-sort-up" => "sort up",
    "fa-envelope" => "envelope",
    "fa-linkedin" => "linkedin",
    "fa-rotate-left" => "rotate left",
    "fa-legal" => "legal",
    "fa-dashboard" => "dashboard",
    "fa-comment-o" => "comment o",
    "fa-comments-o" => "comments o",
    "fa-flash" => "flash",
    "fa-sitemap" => "sitemap",
    "fa-umbrella" => "umbrella",
    "fa-paste" => "paste",
    "fa-lightbulb-o" => "lightbulb o",
    "fa-exchange" => "exchange",
    "fa-cloud-download" => "cloud download",
    "fa-cloud-upload" => "cloud upload",
    "fa-user-md" => "user md",
    "fa-stethoscope" => "stethoscope",
    "fa-suitcase" => "suitcase",
    "fa-bell-o" => "bell o",
    "fa-coffee" => "coffee",
    "fa-cutlery" => "cutlery",
    "fa-file-text-o" => "file text o",
    "fa-building-o" => "building o",
    "fa-hospital-o" => "hospital o",
    "fa-ambulance" => "ambulance",
    "fa-medkit" => "medkit",
    "fa-fighter-jet" => "fighter jet",
    "fa-beer" => "beer",
    "fa-h-square" => "h square",
    "fa-plus-square" => "plus square",
    "fa-angle-double-left" => "angle double left",
    "fa-angle-double-right" => "angle double right",
    "fa-angle-double-up" => "angle double up",
    "fa-angle-double-down" => "angle double down",
    "fa-angle-left" => "angle left",
    "fa-angle-right" => "angle right",
    "fa-angle-up" => "angle up",
    "fa-angle-down" => "angle down",
    "fa-desktop" => "desktop",
    "fa-laptop" => "laptop",
    "fa-tablet" => "tablet",
    "fa-mobile-phone" => "mobile phone",
    "fa-circle-o" => "circle o",
    "fa-quote-left" => "quote left",
    "fa-quote-right" => "quote right",
    "fa-spinner" => "spinner",
    "fa-circle" => "circle",
    "fa-mail-reply" => "mail reply",
    "fa-github-alt" => "github alt",
    "fa-folder-o" => "folder o",
    "fa-folder-open-o" => "folder open o",
    "fa-smile-o" => "smile o",
    "fa-frown-o" => "frown o",
    "fa-meh-o" => "meh o",
    "fa-gamepad" => "gamepad",
    "fa-keyboard-o" => "keyboard o",
    "fa-flag-o" => "flag o",
    "fa-flag-checkered" => "flag checkered",
    "fa-terminal" => "terminal",
    "fa-code" => "code",
    "fa-mail-reply-all" => "mail reply all",
    "fa-star-half-empty" => "star half empty",
    "fa-location-arrow" => "location arrow",
    "fa-crop" => "crop",
    "fa-code-fork" => "code fork",
    "fa-unlink" => "unlink",
    "fa-question" => "question",
    "fa-info" => "info",
    "fa-exclamation" => "exclamation",
    "fa-superscript" => "superscript",
    "fa-subscript" => "subscript",
    "fa-eraser" => "eraser",
    "fa-puzzle-piece" => "puzzle piece",
    "fa-microphone" => "microphone",
    "fa-microphone-slash" => "microphone slash",
    "fa-shield" => "shield",
    "fa-calendar-o" => "calendar o",
    "fa-fire-extinguisher" => "fire extinguisher",
    "fa-rocket" => "rocket",
    "fa-maxcdn" => "maxcdn",
    "fa-chevron-circle-left" => "chevron circle left",
    "fa-chevron-circle-right" => "chevron circle right",
    "fa-chevron-circle-up" => "chevron circle up",
    "fa-chevron-circle-down" => "chevron circle down",
    "fa-html5" => "html5",
    "fa-css3" => "css3",
    "fa-anchor" => "anchor",
    "fa-unlock-alt" => "unlock alt",
    "fa-bullseye" => "bullseye",
    "fa-ellipsis-h" => "ellipsis h",
    "fa-ellipsis-v" => "ellipsis v",
    "fa-rss-square" => "rss square",
    "fa-play-circle" => "play circle",
    "fa-ticket" => "ticket",
    "fa-minus-square" => "minus square",
    "fa-minus-square-o" => "minus square o",
    "fa-level-up" => "level up",
    "fa-level-down" => "level down",
    "fa-check-square" => "check square",
    "fa-pencil-square" => "pencil square",
    "fa-external-link-square" => "external link square",
    "fa-share-square" => "share square",
    "fa-compass" => "compass",
    "fa-toggle-down" => "toggle down",
    "fa-toggle-up" => "toggle up",
    "fa-toggle-right" => "toggle right",
    "fa-euro" => "euro",
    "fa-gbp" => "gbp",
    "fa-dollar" => "dollar",
    "fa-rupee" => "rupee",
    "fa-cny" => "cny",
    "fa-ruble" => "ruble",
    "fa-won" => "won",
    "fa-bitcoin" => "bitcoin",
    "fa-file" => "file",
    "fa-file-text" => "file text",
    "fa-sort-alpha-asc" => "sort alpha asc",
    "fa-sort-alpha-desc" => "sort alpha desc",
    "fa-sort-amount-asc" => "sort amount asc",
    "fa-sort-amount-desc" => "sort amount desc",
    "fa-sort-numeric-asc" => "sort numeric asc",
    "fa-sort-numeric-desc" => "sort numeric desc",
    "fa-thumbs-up" => "thumbs up",
    "fa-thumbs-down" => "thumbs down",
    "fa-youtube-square" => "youtube square",
    "fa-youtube" => "youtube",
    "fa-xing" => "xing",
    "fa-xing-square" => "xing square",
    "fa-youtube-play" => "youtube play",
    "fa-dropbox" => "dropbox",
    "fa-stack-overflow" => "stack overflow",
    "fa-instagram" => "instagram",
    "fa-flickr" => "flickr",
    "fa-adn" => "adn",
    "fa-bitbucket" => "bitbucket",
    "fa-bitbucket-square" => "bitbucket square",
    "fa-tumblr" => "tumblr",
    "fa-tumblr-square" => "tumblr square",
    "fa-long-arrow-down" => "long arrow down",
    "fa-long-arrow-up" => "long arrow up",
    "fa-long-arrow-left" => "long arrow left",
    "fa-long-arrow-right" => "long arrow right",
    "fa-apple" => "apple",
    "fa-windows" => "windows",
    "fa-android" => "android",
    "fa-linux" => "linux",
    "fa-dribbble" => "dribbble",
    "fa-skype" => "skype",
    "fa-foursquare" => "foursquare",
    "fa-trello" => "trello",
    "fa-female" => "female",
    "fa-male" => "male",
    "fa-gittip" => "gittip",
    "fa-sun-o" => "sun o",
    "fa-moon-o" => "moon o",
    "fa-archive" => "archive",
    "fa-bug" => "bug",
    "fa-vk" => "vk",
    "fa-weibo" => "weibo",
    "fa-renren" => "renren",
    "fa-pagelines" => "pagelines",
    "fa-stack-exchange" => "stack exchange",
    "fa-arrow-circle-o-right" => "arrow circle o right",
    "fa-arrow-circle-o-left" => "arrow circle o left",
    "fa-toggle-left" => "toggle left",
    "fa-dot-circle-o" => "dot circle o",
    "fa-wheelchair" => "wheelchair",
    "fa-vimeo-square" => "vimeo square",
    "fa-turkish-lira" => "turkish lira",
    "fa-plus-square-o" => "plus square o",
    "fa-space-shuttle" => "space shuttle",
    "fa-slack" => "slack",
    "fa-envelope-square" => "envelope square",
    "fa-wordpress" => "wordpress",
    "fa-openid" => "openid",
    "fa-institution" => "institution",
    "fa-mortar-board" => "mortar board",
    "fa-yahoo" => "yahoo",
    "fa-google" => "google",
    "fa-reddit" => "reddit",
    "fa-reddit-square" => "reddit square",
    "fa-stumbleupon-circle" => "stumbleupon circle",
    "fa-stumbleupon" => "stumbleupon",
    "fa-delicious" => "delicious",
    "fa-digg" => "digg",
    "fa-pied-piper-pp" => "pied piper pp",
    "fa-pied-piper-alt" => "pied piper alt",
    "fa-drupal" => "drupal",
    "fa-joomla" => "joomla",
    "fa-language" => "language",
    "fa-fax" => "fax",
    "fa-building" => "building",
    "fa-child" => "child",
    "fa-paw" => "paw",
    "fa-spoon" => "spoon",
    "fa-cube" => "cube",
    "fa-cubes" => "cubes",
    "fa-behance" => "behance",
    "fa-behance-square" => "behance square",
    "fa-steam" => "steam",
    "fa-steam-square" => "steam square",
    "fa-recycle" => "recycle",
    "fa-automobile" => "automobile",
    "fa-cab" => "cab",
    "fa-tree" => "tree",
    "fa-spotify" => "spotify",
    "fa-deviantart" => "deviantart",
    "fa-soundcloud" => "soundcloud",
    "fa-database" => "database",
    "fa-file-pdf-o" => "file pdf o",
    "fa-file-word-o" => "file word o",
    "fa-file-excel-o" => "file excel o",
    "fa-file-powerpoint-o" => "file powerpoint o",
    "fa-file-photo-o" => "file photo o",
    "fa-file-zip-o" => "file zip o",
    "fa-file-sound-o" => "file sound o",
    "fa-file-movie-o" => "file movie o",
    "fa-file-code-o" => "file code o",
    "fa-vine" => "vine",
    "fa-codepen" => "codepen",
    "fa-jsfiddle" => "jsfiddle",
    "fa-life-bouy" => "life bouy",
    "fa-circle-o-notch" => "circle o notch",
    "fa-ra" => "ra",
    "fa-ge" => "ge",
    "fa-git-square" => "git square",
    "fa-git" => "git",
    "fa-y-combinator-square" => "y combinator square",
    "fa-tencent-weibo" => "tencent weibo",
    "fa-qq" => "qq",
    "fa-wechat" => "wechat",
    "fa-send" => "send",
    "fa-send-o" => "send o",
    "fa-history" => "history",
    "fa-circle-thin" => "circle thin",
    "fa-header" => "header",
    "fa-paragraph" => "paragraph",
    "fa-sliders" => "sliders",
    "fa-share-alt" => "share alt",
    "fa-share-alt-square" => "share alt square",
    "fa-bomb" => "bomb",
    "fa-soccer-ball-o" => "soccer ball o",
    "fa-tty" => "tty",
    "fa-binoculars" => "binoculars",
    "fa-plug" => "plug",
    "fa-slideshare" => "slideshare",
    "fa-twitch" => "twitch",
    "fa-yelp" => "yelp",
    "fa-newspaper-o" => "newspaper o",
    "fa-wifi" => "wifi",
    "fa-calculator" => "calculator",
    "fa-paypal" => "paypal",
    "fa-google-wallet" => "google wallet",
    "fa-cc-visa" => "cc visa",
    "fa-cc-mastercard" => "cc mastercard",
    "fa-cc-discover" => "cc discover",
    "fa-cc-amex" => "cc amex",
    "fa-cc-paypal" => "cc paypal",
    "fa-cc-stripe" => "cc stripe",
    "fa-bell-slash" => "bell slash",
    "fa-bell-slash-o" => "bell slash o",
    "fa-trash" => "trash",
    "fa-copyright" => "copyright",
    "fa-at" => "at",
    "fa-eyedropper" => "eyedropper",
    "fa-paint-brush" => "paint brush",
    "fa-birthday-cake" => "birthday cake",
    "fa-area-chart" => "area chart",
    "fa-pie-chart" => "pie chart",
    "fa-line-chart" => "line chart",
    "fa-lastfm" => "lastfm",
    "fa-lastfm-square" => "lastfm square",
    "fa-toggle-off" => "toggle off",
    "fa-toggle-on" => "toggle on",
    "fa-bicycle" => "bicycle",
    "fa-bus" => "bus",
    "fa-ioxhost" => "ioxhost",
    "fa-angellist" => "angellist",
    "fa-cc" => "cc",
    "fa-shekel" => "shekel",
    "fa-meanpath" => "meanpath",
    "fa-buysellads" => "buysellads",
    "fa-connectdevelop" => "connectdevelop",
    "fa-dashcube" => "dashcube",
    "fa-forumbee" => "forumbee",
    "fa-leanpub" => "leanpub",
    "fa-sellsy" => "sellsy",
    "fa-shirtsinbulk" => "shirtsinbulk",
    "fa-simplybuilt" => "simplybuilt",
    "fa-skyatlas" => "skyatlas",
    "fa-cart-plus" => "cart plus",
    "fa-cart-arrow-down" => "cart arrow down",
    "fa-diamond" => "diamond",
    "fa-ship" => "ship",
    "fa-user-secret" => "user secret",
    "fa-motorcycle" => "motorcycle",
    "fa-street-view" => "street view",
    "fa-heartbeat" => "heartbeat",
    "fa-venus" => "venus",
    "fa-mars" => "mars",
    "fa-mercury" => "mercury",
    "fa-intersex" => "intersex",
    "fa-transgender-alt" => "transgender alt",
    "fa-venus-double" => "venus double",
    "fa-mars-double" => "mars double",
    "fa-venus-mars" => "venus mars",
    "fa-mars-stroke" => "mars stroke",
    "fa-mars-stroke-v" => "mars stroke v",
    "fa-mars-stroke-h" => "mars stroke h",
    "fa-neuter" => "neuter",
    "fa-genderless" => "genderless",
    "fa-facebook-official" => "facebook official",
    "fa-pinterest-p" => "pinterest p",
    "fa-whatsapp" => "whatsapp",
    "fa-server" => "server",
    "fa-user-plus" => "user plus",
    "fa-user-times" => "user times",
    "fa-hotel" => "hotel",
    "fa-viacoin" => "viacoin",
    "fa-train" => "train",
    "fa-subway" => "subway",
    "fa-medium" => "medium",
    "fa-yc" => "yc",
    "fa-optin-monster" => "optin monster",
    "fa-opencart" => "opencart",
    "fa-expeditedssl" => "expeditedssl",
    "fa-battery-4" => "battery 4",
    "fa-battery-3" => "battery 3",
    "fa-battery-2" => "battery 2",
    "fa-battery-1" => "battery 1",
    "fa-battery-0" => "battery 0",
    "fa-mouse-pointer" => "mouse pointer",
    "fa-i-cursor" => "i cursor",
    "fa-object-group" => "object group",
    "fa-object-ungroup" => "object ungroup",
    "fa-sticky-note" => "sticky note",
    "fa-sticky-note-o" => "sticky note o",
    "fa-cc-jcb" => "cc jcb",
    "fa-cc-diners-club" => "cc diners club",
    "fa-clone" => "clone",
    "fa-balance-scale" => "balance scale",
    "fa-hourglass-o" => "hourglass o",
    "fa-hourglass-1" => "hourglass 1",
    "fa-hourglass-2" => "hourglass 2",
    "fa-hourglass-3" => "hourglass 3",
    "fa-hourglass" => "hourglass",
    "fa-hand-grab-o" => "hand grab o",
    "fa-hand-stop-o" => "hand stop o",
    "fa-hand-scissors-o" => "hand scissors o",
    "fa-hand-lizard-o" => "hand lizard o",
    "fa-hand-spock-o" => "hand spock o",
    "fa-hand-pointer-o" => "hand pointer o",
    "fa-hand-peace-o" => "hand peace o",
    "fa-trademark" => "trademark",
    "fa-registered" => "registered",
    "fa-creative-commons" => "creative commons",
    "fa-gg" => "gg",
    "fa-gg-circle" => "gg circle",
    "fa-tripadvisor" => "tripadvisor",
    "fa-odnoklassniki" => "odnoklassniki",
    "fa-odnoklassniki-square" => "odnoklassniki square",
    "fa-get-pocket" => "get pocket",
    "fa-wikipedia-w" => "wikipedia w",
    "fa-safari" => "safari",
    "fa-chrome" => "chrome",
    "fa-firefox" => "firefox",
    "fa-opera" => "opera",
    "fa-internet-explorer" => "internet explorer",
    "fa-tv" => "tv",
    "fa-contao" => "contao",
    "fa-500px" => "500px",
    "fa-amazon" => "amazon",
    "fa-calendar-plus-o" => "calendar plus o",
    "fa-calendar-minus-o" => "calendar minus o",
    "fa-calendar-times-o" => "calendar times o",
    "fa-calendar-check-o" => "calendar check o",
    "fa-industry" => "industry",
    "fa-map-pin" => "map pin",
    "fa-map-signs" => "map signs",
    "fa-map-o" => "map o",
    "fa-map" => "map",
    "fa-commenting" => "commenting",
    "fa-commenting-o" => "commenting o",
    "fa-houzz" => "houzz",
    "fa-vimeo" => "vimeo",
    "fa-black-tie" => "black tie",
    "fa-fonticons" => "fonticons",
    "fa-reddit-alien" => "reddit alien",
    "fa-edge" => "edge",
    "fa-credit-card-alt" => "credit card alt",
    "fa-codiepie" => "codiepie",
    "fa-modx" => "modx",
    "fa-fort-awesome" => "fort awesome",
    "fa-usb" => "usb",
    "fa-product-hunt" => "product hunt",
    "fa-mixcloud" => "mixcloud",
    "fa-scribd" => "scribd",
    "fa-pause-circle" => "pause circle",
    "fa-pause-circle-o" => "pause circle o",
    "fa-stop-circle" => "stop circle",
    "fa-stop-circle-o" => "stop circle o",
    "fa-shopping-bag" => "shopping bag",
    "fa-shopping-basket" => "shopping basket",
    "fa-hashtag" => "hashtag",
    "fa-bluetooth" => "bluetooth",
    "fa-bluetooth-b" => "bluetooth b",
    "fa-percent" => "percent",
    "fa-gitlab" => "gitlab",
    "fa-wpbeginner" => "wpbeginner",
    "fa-wpforms" => "wpforms",
    "fa-envira" => "envira",
    "fa-universal-access" => "universal access",
    "fa-wheelchair-alt" => "wheelchair alt",
    "fa-question-circle-o" => "question circle o",
    "fa-blind" => "blind",
    "fa-audio-description" => "audio description",
    "fa-volume-control-phone" => "volume control phone",
    "fa-braille" => "braille",
    "fa-assistive-listening-systems" => "assistive listening systems",
    "fa-asl-interpreting" => "asl interpreting",
    "fa-deafness" => "deafness",
    "fa-glide" => "glide",
    "fa-glide-g" => "glide g",
    "fa-signing" => "signing",
    "fa-low-vision" => "low vision",
    "fa-viadeo" => "viadeo",
    "fa-viadeo-square" => "viadeo square",
    "fa-snapchat" => "snapchat",
    "fa-snapchat-ghost" => "snapchat ghost",
    "fa-snapchat-square" => "snapchat square",
    "fa-pied-piper" => "pied piper",
    "fa-first-order" => "first order",
    "fa-yoast" => "yoast",
    "fa-themeisle" => "themeisle",
    "fa-google-plus-circle" => "google plus circle",
    "fa-fa" => "fa",
    "fa-handshake-o" => "handshake o",
    "fa-envelope-open" => "envelope open",
    "fa-envelope-open-o" => "envelope open o",
    "fa-linode" => "linode",
    "fa-address-book" => "address book",
    "fa-address-book-o" => "address book o",
    "fa-vcard" => "vcard",
    "fa-vcard-o" => "vcard o",
    "fa-user-circle" => "user circle",
    "fa-user-circle-o" => "user circle o",
    "fa-user-o" => "user o",
    "fa-id-badge" => "id badge",
    "fa-drivers-license" => "drivers license",
    "fa-drivers-license-o" => "drivers license o",
    "fa-quora" => "quora",
    "fa-free-code-camp" => "free code camp",
    "fa-telegram" => "telegram",
    "fa-thermometer-4" => "thermometer 4",
    "fa-thermometer-3" => "thermometer 3",
    "fa-thermometer-2" => "thermometer 2",
    "fa-thermometer-1" => "thermometer 1",
    "fa-thermometer-0" => "thermometer 0",
    "fa-shower" => "shower",
    "fa-bathtub" => "bathtub",
    "fa-podcast" => "podcast",
    "fa-window-maximize" => "window maximize",
    "fa-window-minimize" => "window minimize",
    "fa-window-restore" => "window restore",
    "fa-times-rectangle" => "times rectangle",
    "fa-times-rectangle-o" => "times rectangle o",
    "fa-bandcamp" => "bandcamp",
    "fa-grav" => "grav",
    "fa-etsy" => "etsy",
    "fa-imdb" => "imdb",
    "fa-ravelry" => "ravelry",
    "fa-eercast" => "eercast",
    "fa-microchip" => "microchip",
    "fa-snowflake-o" => "snowflake o",
    "fa-superpowers" => "superpowers",
    "fa-wpexplorer" => "wpexplorer",
    "fa-meetup" => "meetup",
);

$paletteList = array(
    'default' => array(
        'label' => esc_html__('Default', 'otw_bmp' ),
        'items' => array(
            '#ff0000' => esc_html__('Red', 'otw_bmp' ),
            '#ff00ff' => esc_html__('Pink', 'otw_bmp' ),
            '#800080' => esc_html__('Purple', 'otw_bmp' ),
            '#4b0082' => esc_html__('Indigo', 'otw_bmp' ),
            '#0000ff' => esc_html__('Blue', 'otw_bmp' ),
            '#00ffff' => esc_html__('Light Blue', 'otw_bmp' ),
            '#008080' => esc_html__('Teal', 'otw_bmp' ),
            '#008000' => esc_html__('Green', 'otw_bmp' ),
            '#adff2f' => esc_html__('Light Green', 'otw_bmp' ),
            '#ffff00' => esc_html__('Yellow', 'otw_bmp' ),
            '#ffa500' => esc_html__('Orange', 'otw_bmp' ),
            '#a52a2a' => esc_html__('Brown', 'otw_bmp' ),
        ),
    ),
    'pale' => array(
        'label' => esc_html__('Pale', 'otw_bmp' ),
        'items' => array(
            '#fee0d2' => esc_html__('Red', 'otw_bmp' ),
            '#fde0dd' => esc_html__('Pink', 'otw_bmp' ),
            '#efedf5' => esc_html__('Purple', 'otw_bmp' ),
            '#a6bddb' => esc_html__('Indigo', 'otw_bmp' ),
            '#e0ecf4' => esc_html__('Blue', 'otw_bmp' ),
            '#e5f5f9' => esc_html__('Light Blue', 'otw_bmp' ),
            '#ccece6' => esc_html__('Teal', 'otw_bmp' ),
            '#e5f5e0' => esc_html__('Green', 'otw_bmp' ),
            '#edf8b1' => esc_html__('Light Green', 'otw_bmp' ),
            '#ffffe5' => esc_html__('Yellow', 'otw_bmp' ),
            '#fee6ce' => esc_html__('Orange', 'otw_bmp' ),
            '#f0cfbb' => esc_html__('Brown', 'otw_bmp' ),
        ),
    ),
    'pastel' => array(
        'label' => esc_html__('Pastel', 'otw_bmp' ),
        'items' => array(
            '#fc9272' => esc_html__('Red', 'otw_bmp' ),
            '#fa9fb5' => esc_html__('Pink', 'otw_bmp' ),
            '#bcbddc' => esc_html__('Purple', 'otw_bmp' ),
            '#838fcc' => esc_html__('Indigo', 'otw_bmp' ),
            '#9ebcda' => esc_html__('Blue', 'otw_bmp' ),
            '#c6dbef' => esc_html__('Light Blue', 'otw_bmp' ),
            '#66c2a4' => esc_html__('Teal', 'otw_bmp' ),
            '#a1d99b' => esc_html__('Green', 'otw_bmp' ),
            '#ccebc5' => esc_html__('Light Green', 'otw_bmp' ),
            '#fff59e' => esc_html__('Yellow', 'otw_bmp' ),
            '#fdbb84' => esc_html__('Orange', 'otw_bmp' ),
            '#a1887f' => esc_html__('Brown', 'otw_bmp' ),
        ),
    ),
    'material' => array(
        'label' => esc_html__('Material', 'otw_bmp' ),
        'items' => array(
            '#f44337' => esc_html__('Red', 'otw_bmp' ),
            '#e91e63' => esc_html__('Pink', 'otw_bmp' ),
            '#9c27b0' => esc_html__('Purple', 'otw_bmp' ),
            '#3f51b5' => esc_html__('Indigo', 'otw_bmp' ),
            '#2196f3' => esc_html__('Blue', 'otw_bmp' ),
            '#17a9f4' => esc_html__('Light Blue', 'otw_bmp' ),
            '#0f9687' => esc_html__('Teal', 'otw_bmp' ),
            '#4caf50' => esc_html__('Green', 'otw_bmp' ),
            '#8bc34a' => esc_html__('Light Green', 'otw_bmp' ),
            '#feeb3b' => esc_html__('Yellow', 'otw_bmp' ),
            '#fe9800' => esc_html__('Orange', 'otw_bmp' ),
            '#795548' => esc_html__('Brown', 'otw_bmp' ),
        ),
    ),
    'ios' => array(
        'label' => esc_html__('iOS', 'otw_bmp' ),
        'items' => array(
            '#ff3b30' => esc_html__('Red', 'otw_bmp' ),
            '#ff2d55' => esc_html__('Pink', 'otw_bmp' ),
            '#c064ea' => esc_html__('Purple', 'otw_bmp' ),
            '#5856d6' => esc_html__('Indigo', 'otw_bmp' ),
            '#127aff' => esc_html__('Blue', 'otw_bmp' ),
            '#5ac8fa' => esc_html__('Light Blue', 'otw_bmp' ),
            '#1ac5bf' => esc_html__('Teal', 'otw_bmp' ),
            '#4cd964' => esc_html__('Green', 'otw_bmp' ),
            '#87fc70' => esc_html__('Light Green', 'otw_bmp' ),
            '#ffcc00' => esc_html__('Yellow', 'otw_bmp' ),
            '#ff9500' => esc_html__('Orange', 'otw_bmp' ),
            '#d84315' => esc_html__('Brown', 'otw_bmp' ),
        ),
    ),
    'vibrant' => array(
        'label' => esc_html__('Vibrant', 'otw_bmp' ),
        'items' => array(
            '#f51457' => esc_html__('Red', 'otw_bmp' ),
            '#f51457' => esc_html__('Pink', 'otw_bmp' ),
            '#d512f9' => esc_html__('Purple', 'otw_bmp' ),
            '#3d5afe' => esc_html__('Indigo', 'otw_bmp' ),
            '#2979ff' => esc_html__('Blue', 'otw_bmp' ),
            '#18b0ff' => esc_html__('Light Blue', 'otw_bmp' ),
            '#1de9b6' => esc_html__('Teal', 'otw_bmp' ),
            '#76fe03' => esc_html__('Green', 'otw_bmp' ),
            '#c6ff00' => esc_html__('Light Green', 'otw_bmp' ),
            '#fed601' => esc_html__('Yellow', 'otw_bmp' ),
            '#fe9101' => esc_html__('Orange', 'otw_bmp' ),
            '#bf360c' => esc_html__('Brown', 'otw_bmp' ),
        ),
    ),
    'dark' => array(
        'label' => esc_html__('Dark', 'otw_bmp' ),
        'items' => array(
            '#a50f15' => esc_html__('Red', 'otw_bmp' ),
            '#7a0177' => esc_html__('Pink', 'otw_bmp' ),
            '#54278f' => esc_html__('Purple', 'otw_bmp' ),
            '#08306b' => esc_html__('Indigo', 'otw_bmp' ),
            '#045a8d' => esc_html__('Blue', 'otw_bmp' ),
            '#2b8cbe' => esc_html__('Light Blue', 'otw_bmp' ),
            '#016c59' => esc_html__('Teal', 'otw_bmp' ),
            '#006d2c' => esc_html__('Green', 'otw_bmp' ),
            '#238b45' => esc_html__('Light Green', 'otw_bmp' ),
            '#cca01d' => esc_html__('Yellow', 'otw_bmp' ),
            '#a63603' => esc_html__('Orange', 'otw_bmp' ),
            '#662506' => esc_html__('Brown', 'otw_bmp' ),
        ),
    ),
);

$positionOptions = array(
    'left' => 'left',
    'right' => 'right',
);

$editSections = array(
    'font_text' => array(
        'title' => esc_html__('Text', 'otw_bmp' ),
        'elements' => array(
            'upper_text' => array(
                'enabled' => true,
                'id' => 'button_upper_text',
                'name' => 'button_upper_text',
                'label' => esc_html__('Upper text:', 'otw_bmp' ),
                'description' => esc_html__('The text above the main button text', 'otw_bmp' ),
                'admin_func' => 'otw_admin_text',
                'data-target' => 'upper_text',
                'config' => array(),
            ),
            'title' => array(
                'enabled' => true,
                'id' => 'button_title',
                'name' => 'button_title',
                'label' => esc_html__('Title:', 'otw_bmp' ),
                'description' => esc_html__('The text of the button', 'otw_bmp' ),
                'admin_func' => 'otw_admin_text',
                'data-target' => 'text',
                'config' => array(),
            ),
            'sub_title' => array(
                'enabled' => true,
                'id' => 'sub_button_title',
                'name' => 'sub_button_title',
                'label' => esc_html__('Subtitle:', 'otw_bmp' ),
                'description' => esc_html__('The text under the main button text', 'otw_bmp' ),
                'admin_func' => 'otw_admin_text',
                'data-target' => 'sub_title',
                'config' => array(),
            ),
            'font-family' => array(
                'enabled' => true,
                'id' => 'button_parent_font_family',
                'name' => 'button_parent_style[font-family]',
                'label' => esc_html__('Font family:', 'otw_bmp' ),
                'description' => esc_html__('Set the button text font', 'otw_bmp' ),
                'property' => 'font-family',
                'admin_func' => 'otw_admin_drop_down',
                'data-target' => 'parent_style',
                'config' => array(
                    'class' => 'js-fonts otw-form-text-input select2-wrapper',
                    'options' => $webSafeFonts, // $webSafeFonts,
                    'format' => 'select2',
                ),
                'section' => 'button_parent_style',
            ),
            'font-weight' => array(
                'enabled' => true,
                'id' => 'button_style_font_weight',
                'name' => 'button_style[font-weight]',
                'label' => esc_html__('Bold', 'otw_bmp' ),
                'description' => esc_html__('Bold text', 'otw_bmp' ),
                'property' => 'font-weight',
                'value' => 'bold',
                'admin_func' => 'otw_admin_checkbox',
                'data-id' => 'font-weight',
                'data-target' => 'content_styleOnOff',
                'section' => 'button_style',
            ),
            'font-style' => array(
                'enabled' => true,
                'id' => 'button_style_font_style',
                'name' => 'button_style[font-style]',
                'label' => esc_html__('Italic', 'otw_bmp' ),
                'description' => esc_html__('Italic text', 'otw_bmp' ),
                'property' => 'font-style',
                'value' => 'italic',
                'admin_func' => 'otw_admin_checkbox',
                'data-id' => 'font-style',
                'data-target' => 'content_styleOnOff',
                'section' => 'button_style',
            ),
            'text-transform' => array(
                'enabled' => true,
                'id' => 'button_style_text_transform',
                'name' => 'button_style[text-transform]',
                'label' => esc_html__('Uppercase', 'otw_bmp' ),
                'description' => esc_html__('ALL CAPS', 'otw_bmp' ),
                'property' => 'text-transform',
                'value' => 'uppercase',
                'admin_func' => 'otw_admin_checkbox',
                'data-id' => 'text-transform',
                'data-target' => 'content_styleOnOff',
                'section' => 'button_style',
            ),
            'color' => array(
                'enabled' => true,
                'id' => 'button_color',
                'name' => 'button_style[color]',
                'label' => esc_html__('Font color:', 'otw_bmp' ),
                'description' => esc_html__('Set the color of the button text', 'otw_bmp' ),
                'property' => 'color',
                'admin_func' => 'otw_admin_color_picker',
                'data-target' => 'content_style',
                'section' => 'button_style',
                'config' => array(
            		'format' => 'with_selector'
                )
            ),
            'font-size' => array(
                'enabled' => true,
                'label' => esc_html__('Font size:', 'otw_bmp' ),
                'description' => esc_html__('Set the size of the button text', 'otw_bmp' ),
                'width' => '300px', //'635px',
                'linkedElement' => 'button_font_size',
                'sliderId' => 'font-size-slider',
                'sliderMin' => 8,
                'sliderMax' => 52,
                'sliderStep' => 2,
                'property' => 'font-size',
                'admin_func' => 'otw_admin_slider',
                'config' => array(),
            ),
            'text-shadow' => array(
                'enabled' => true,
                'grouped' => true,
                'id' => 'button_style_text_shadow',
                'name' => 'button_style[text-shadow]',
                'label' => esc_html__('Text shadow', 'otw_bmp' ),
                'description' => esc_html__('Text shadow', 'otw_bmp' ),
                'property' => 'text-shadow',
                'section' => 'button_style',
                'children' => array(
                    'horizontal' => array(
                        'enabled' => true,
                        'name' => 'button_style[text-shadow][horizontal]',
                        'label' => esc_html__('Text shadow horizontal length:', 'otw_bmp' ),
                        'description' => esc_html__('Text shadow horizontal length', 'otw_bmp' ),
                        'width' => '300px', //'635px',
                        'linkedElement' => 'button_text_shadow_h',
                        'sliderId' => 'text-shadow-horizontal-length-slider',
                        'sliderMin' => -20,
                        'sliderMax' => 20,
                        'sliderStep' => 1,
                        'admin_func' => 'otw_admin_slider',
                        'property' => 'content_text_shadow|horizontal',
                        'config' => array(
                            'target' => 'text_shadow',
                            'group' => 'content_text_shadow',
                        ),
                    ),
                    'vertical' => array(
                        'enabled' => true,
                        'name' => 'button_style[text-shadow][vertical]',
                        'label' => esc_html__('Text shadow vertical length:', 'otw_bmp' ),
                        'description' => esc_html__('Text shadow vertical length', 'otw_bmp' ),
                        'width' => '300px', //'635px',
                        'linkedElement' => 'button_text_shadow_v',
                        'sliderId' => 'text-shadow-vertical-length-slider',
                        'sliderMin' => -20,
                        'sliderMax' => 20,
                        'sliderStep' => 1,
                        'admin_func' => 'otw_admin_slider',
                        'property' => 'content_text_shadow|vertical',
                        'config' => array(
                            'target' => 'text_shadow',
                            'group' => 'content_text_shadow',
                        ),
                    ),
                    'blur' => array(
                        'enabled' => true,
                        'name' => 'button_style[text-shadow][blur]',
                        'label' => esc_html__('Text shadow blur radius:', 'otw_bmp' ),
                        'description' => esc_html__('Text shadow blur radius', 'otw_bmp' ),
                        'width' => '300px', //'635px',
                        'linkedElement' => 'button_text_shadow_b',
                        'sliderId' => 'text-shadow-vertical-length-slider',
                        'sliderMin' => 0,
                        'sliderMax' => 25,
                        'sliderStep' => 1,
                        'admin_func' => 'otw_admin_slider',
                        'property' => 'content_text_shadow|blur',
                        'config' => array(
                            'target' => 'text_shadow',
                            'group' => 'content_text_shadow',
                        ),
                    ),
                    'color' => array(
                        'enabled' => true,
                        'id' => 'button_text_shadow_color',
                        'name' => 'button_style[text-shadow][color]',
                        'label' => esc_html__('Text shadow color:', 'otw_bmp' ),
                        'description' => esc_html__('Set the color of the button text shadow', 'otw_bmp' ),
                        'property' => 'content_text_shadow|color',
                        'admin_func' => 'otw_admin_color_picker',
                        'section' => '',
                        'data-target' => 'text_shadow',
                        'data-group' => 'content_text_shadow',
                        'config' => array(),
                    ),
                ),
            ),
        ),
    ),
    'upper_font_text' => array(
        'title' => esc_html__('Upper Text', 'otw_bmp' ),
        'elements' => array(
            'upper-title' => array(
                'enabled' => true,
                'id' => 'upper_button_title',
                'name' => 'upper_button_title',
                'label' => esc_html__('Title:', 'otw_bmp' ),
                'description' => esc_html__('The text of the button', 'otw_bmp' ),
                'admin_func' => 'otw_admin_text',
                'data-target' => 'upper_text',
                'config' => array(),
            ),
            'font-weight' => array(
                'enabled' => true,
                'id' => 'upper_button_style_font_weight',
                'name' => 'upper_button_style[font-weight]',
                'label' => esc_html__('Bold', 'otw_bmp' ),
                'description' => esc_html__('Bold text', 'otw_bmp' ),
                'property' => 'font-weight',
                'value' => 'bold',
                'admin_func' => 'otw_admin_checkbox',
                'data-id' => 'font-weight',
                'data-target' => 'upper_styleOnOff',
                'section' => 'upper_button_style',
            ),
            'font-style' => array(
                'enabled' => true,
                'id' => 'upper_button_style_font_style',
                'name' => 'upper_button_style[font-style]',
                'label' => esc_html__('Italic', 'otw_bmp' ),
                'description' => esc_html__('Italic text', 'otw_bmp' ),
                'property' => 'font-style',
                'value' => 'italic',
                'admin_func' => 'otw_admin_checkbox',
                'data-id' => 'font-style',
                'data-target' => 'upper_styleOnOff',
                'section' => 'upper_button_style',
            ),
            'text-transform' => array(
                'enabled' => true,
                'id' => 'upper_button_style_text_transform',
                'name' => 'upper_button_style[text-transform]',
                'label' => esc_html__('Uppercase', 'otw_bmp' ),
                'description' => esc_html__('ALL CAPS', 'otw_bmp' ),
                'property' => 'text-transform',
                'value' => 'uppercase',
                'admin_func' => 'otw_admin_checkbox',
                'data-id' => 'text-transform',
                'data-target' => 'upper_styleOnOff',
                'section' => 'upper_button_style',
            ),
            'color' => array(
                'enabled' => true,
                'id' => 'upper_button_color',
                'name' => 'upper_button_style[color]',
                'label' => esc_html__('Font color:', 'otw_bmp' ),
                'description' => esc_html__('Set the color of the button text', 'otw_bmp' ),
                'property' => 'color',
                'admin_func' => 'otw_admin_color_picker',
                'data-target' => 'upper_style',
                'section' => 'upper_button_style',
            ),
            'font-size' => array(
                'enabled' => true,
                'label' => esc_html__('Font size:', 'otw_bmp' ),
                'description' => esc_html__('Set the size of the button text', 'otw_bmp' ),
                'width' => '300px', //'635px',
                'linkedElement' => 'upper_button_font_size',
                'sliderId' => 'upper-font-size-slider',
                'sliderMin' => 8,
                'sliderMax' => 52,
                'sliderStep' => 2,
                'property' => 'font-size',
                'admin_func' => 'otw_admin_slider',
                'section' => 'upper_button_style',
                'config' => array(),
            ),
            'text-align' => array(
                'enabled' => true,
                'id' => 'upper_button_text_align',
                'name' => 'upper_button_style[text-align]',
                'label' => esc_html__('Text Alignment:', 'otw_bmp' ),
                'description' => esc_html__('Set the upper button text alignment', 'otw_bmp' ),
                'property' => 'text-align',
                'admin_func' => 'otw_admin_drop_down',
                'data-target' => '',
                'config' => array(
                    'options' => array( 'left' => esc_html__( 'left (default)', 'otw_bmp' ), 'center' => esc_html__( 'center', 'otw_bmp' ), 'right' => esc_html__( 'right', 'otw_bmp' ) ),
                ),
                'section' => 'upper_button_style'
            ),
            'background-color' => array(
                'enabled' => true,
                'id' => 'upper_button_background_color',
                'name' => 'upper_button_style[background-color]',
                'label' => esc_html__('Background color:', 'otw_bmp' ),
                'description' => esc_html__('Define the color for the text background', 'otw_bmp' ),
                'property' => 'background-color',
                'admin_func' => 'otw_admin_color_picker',
                'data-target' => '',
                'data-group' => '',
                'section' => 'upper_button_style'
            ),
            'text-shadow' => array(
                'enabled' => true,
                'grouped' => true,
                'id' => 'upper_button_style_text_shadow',
                'name' => 'upper_button_style[text-shadow]',
                'label' => esc_html__('Text shadow', 'otw_bmp' ),
                'description' => esc_html__('Text shadow', 'otw_bmp' ),
                'property' => 'text-shadow',
                'section' => 'upper_button_style',
                'children' => array(
                    'horizontal' => array(
                        'enabled' => true,
                        'name' => 'upper_button_style[text-shadow][horizontal]',
                        'label' => esc_html__('Text shadow horizontal length:', 'otw_bmp' ),
                        'description' => esc_html__('Text shadow horizontal length', 'otw_bmp' ),
                        'width' => '300px', //'635px',
                        'linkedElement' => 'upper_button_text_shadow_h',
                        'sliderId' => 'upper_text-shadow-horizontal-length-slider',
                        'sliderMin' => -20,
                        'sliderMax' => 20,
                        'sliderStep' => 1,
                        'admin_func' => 'otw_admin_slider',
                        'property' => 'upper_content_text_shadow|horizontal',
                        'config' => array(
                            'target' => 'upper_text_shadow',
                            'group' => 'upper_content_text_shadow',
                        ),
                    ),
                    'vertical' => array(
                        'enabled' => true,
                        'name' => 'upper_button_style[text-shadow][vertical]',
                        'label' => esc_html__('Text shadow vertical length:', 'otw_bmp' ),
                        'description' => esc_html__('Text shadow vertical length', 'otw_bmp' ),
                        'width' => '300px', //'635px',
                        'linkedElement' => 'upper_button_text_shadow_v',
                        'sliderId' => 'upper_text-shadow-vertical-length-slider',
                        'sliderMin' => -20,
                        'sliderMax' => 20,
                        'sliderStep' => 1,
                        'admin_func' => 'otw_admin_slider',
                        'property' => 'upper_content_text_shadow|vertical',
                        'config' => array(
                            'target' => 'upper_text_shadow',
                            'group' => 'upper_content_text_shadow',
                        ),
                    ),
                    'blur' => array(
                        'enabled' => true,
                        'name' => 'upper_button_style[text-shadow][blur]',
                        'label' => esc_html__('Text shadow blur radius:', 'otw_bmp' ),
                        'description' => esc_html__('Text shadow blur radius', 'otw_bmp' ),
                        'width' => '300px', //'635px',
                        'linkedElement' => 'upper_button_text_shadow_b',
                        'sliderId' => 'upper_text-shadow-vertical-length-slider',
                        'sliderMin' => 0,
                        'sliderMax' => 25,
                        'sliderStep' => 1,
                        'admin_func' => 'otw_admin_slider',
                        'property' => 'upper_content_text_shadow|blur',
                        'config' => array(
                            'target' => 'upper_text_shadow',
                            'group' => 'upper_content_text_shadow',
                        ),
                    ),
                    'color' => array(
                        'enabled' => true,
                        'id' => 'upper_button_text_shadow_color',
                        'name' => 'upper_button_style[text-shadow][color]',
                        'label' => esc_html__('Text shadow color:', 'otw_bmp' ),
                        'description' => esc_html__('Set the color of the button text shadow', 'otw_bmp' ),
                        'property' => 'upper_content_text_shadow|color',
                        'admin_func' => 'otw_admin_color_picker',
                        'section' => '',
                        'data-target' => 'upper_text_shadow',
                        'data-group' => 'upper_content_text_shadow',
                        'config' => array(),
                    ),
                ),
            ),
        ),
    ),
    'sub_font_text' => array(
        'title' => esc_html__('Sub Text', 'otw_bmp' ),
        'elements' => array(
            'sub-title' => array(
                'enabled' => true,
                'id' => 'sub_button_title',
                'name' => 'sub_button_title',
                'label' => esc_html__('Title:', 'otw_bmp' ),
                'description' => esc_html__('The text of the button', 'otw_bmp' ),
                'admin_func' => 'otw_admin_text',
                'data-target' => 'sub_text',
                'config' => array(),
            ),
            'font-weight' => array(
                'enabled' => true,
                'id' => 'sub_button_style_font_weight',
                'name' => 'sub_button_style[font-weight]',
                'label' => esc_html__('Bold', 'otw_bmp' ),
                'description' => esc_html__('Bold text', 'otw_bmp' ),
                'property' => 'font-weight',
                'value' => 'bold',
                'admin_func' => 'otw_admin_checkbox',
                'data-id' => 'font-weight',
                'data-target' => 'sub_styleOnOff',
                'section' => 'sub_button_style',
            ),
            'font-style' => array(
                'enabled' => true,
                'id' => 'sub_button_style_font_style',
                'name' => 'sub_button_style[font-style]',
                'label' => esc_html__('Italic', 'otw_bmp' ),
                'description' => esc_html__('Italic text', 'otw_bmp' ),
                'property' => 'font-style',
                'value' => 'italic',
                'admin_func' => 'otw_admin_checkbox',
                'data-id' => 'font-style',
                'data-target' => 'sub_styleOnOff',
                'section' => 'sub_button_style',
            ),
            'text-transform' => array(
                'enabled' => true,
                'id' => 'sub_button_style_text_transform',
                'name' => 'sub_button_style[text-transform]',
                'label' => esc_html__('Uppercase', 'otw_bmp' ),
                'description' => esc_html__('ALL CAPS', 'otw_bmp' ),
                'property' => 'text-transform',
                'value' => 'uppercase',
                'admin_func' => 'otw_admin_checkbox',
                'data-id' => 'text-transform',
                'data-target' => 'sub_styleOnOff',
                'section' => 'sub_button_style',
            ),
            'color' => array(
                'enabled' => true,
                'id' => 'sub_button_color',
                'name' => 'sub_button_style[color]',
                'label' => esc_html__('Font color:', 'otw_bmp' ),
                'description' => esc_html__('Set the color of the button text', 'otw_bmp' ),
                'property' => 'color',
                'admin_func' => 'otw_admin_color_picker',
                'data-target' => 'sub_style',
                'section' => 'sub_button_style',
            ),
            'font-size' => array(
                'enabled' => true,
                'label' => esc_html__('Font size:', 'otw_bmp' ),
                'description' => esc_html__('Set the size of the button text', 'otw_bmp' ),
                'width' => '300px', //'635px',
                'linkedElement' => 'sub_button_font_size',
                'sliderId' => 'sub-font-size-slider',
                'sliderMin' => 8,
                'sliderMax' => 52,
                'sliderStep' => 2,
                'property' => 'font-size',
                'admin_func' => 'otw_admin_slider',
                'section' => 'sub_button_style',
                'config' => array(),
            ),
            'text-align' => array(
                'enabled' => true,
                'id' => 'sub_button_text_align',
                'name' => 'sub_button_style[text-align]',
                'label' => esc_html__('Text Alignment:', 'otw_bmp' ),
                'description' => esc_html__('Set the sub button text alignment', 'otw_bmp' ),
                'property' => 'text-align',
                'admin_func' => 'otw_admin_drop_down',
                'data-target' => '',
                'config' => array(
                    'options' => array( 'left' => esc_html__( 'left (default)', 'otw_bmp' ), 'center' => esc_html__( 'center', 'otw_bmp' ), 'right' => esc_html__( 'right', 'otw_bmp' ) ),
                ),
                'section' => 'sub_button_style'
            ),
                'background-color' => array(
                'enabled' => true,
                'id' => 'sub_button_background_color',
                'name' => 'sub_button_style[background-color]',
                'label' => esc_html__('Background color:', 'otw_bmp' ),
                'description' => esc_html__('Define the color for the text background', 'otw_bmp' ),
                'property' => 'background-color',
                'admin_func' => 'otw_admin_color_picker',
                'data-target' => '',
                'data-group' => '',
                'section' => 'sub_button_style'
            ),
            'text-shadow' => array(
                'enabled' => true,
                'grouped' => true,
                'id' => 'sub_button_style_text_shadow',
                'name' => 'sub_button_style[text-shadow]',
                'label' => esc_html__('Text shadow', 'otw_bmp' ),
                'description' => esc_html__('Text shadow', 'otw_bmp' ),
                'property' => 'text-shadow',
                'section' => 'sub_button_style',
                'children' => array(
                    'horizontal' => array(
                        'enabled' => true,
                        'name' => 'sub_button_style[text-shadow][horizontal]',
                        'label' => esc_html__('Text shadow horizontal length:', 'otw_bmp' ),
                        'description' => esc_html__('Text shadow horizontal length', 'otw_bmp' ),
                        'width' => '300px', //'635px',
                        'linkedElement' => 'sub_button_text_shadow_h',
                        'sliderId' => 'sub_text-shadow-horizontal-length-slider',
                        'sliderMin' => -20,
                        'sliderMax' => 20,
                        'sliderStep' => 1,
                        'admin_func' => 'otw_admin_slider',
                        'property' => 'sub_content_text_shadow|horizontal',
                        'config' => array(
                            'target' => 'sub_text_shadow',
                            'group' => 'sub_content_text_shadow',
                        ),
                    ),
                    'vertical' => array(
                        'enabled' => true,
                        'name' => 'sub_button_style[text-shadow][vertical]',
                        'label' => esc_html__('Text shadow vertical length:', 'otw_bmp' ),
                        'description' => esc_html__('Text shadow vertical length', 'otw_bmp' ),
                        'width' => '300px', //'635px',
                        'linkedElement' => 'sub_button_text_shadow_v',
                        'sliderId' => 'sub_text-shadow-vertical-length-slider',
                        'sliderMin' => -20,
                        'sliderMax' => 20,
                        'sliderStep' => 1,
                        'admin_func' => 'otw_admin_slider',
                        'property' => 'sub_content_text_shadow|vertical',
                        'config' => array(
                            'target' => 'sub_text_shadow',
                            'group' => 'sub_content_text_shadow',
                        ),
                    ),
                    'blur' => array(
                        'enabled' => true,
                        'name' => 'sub_button_style[text-shadow][blur]',
                        'label' => esc_html__('Text shadow blur radius:', 'otw_bmp' ),
                        'description' => esc_html__('Text shadow blur radius', 'otw_bmp' ),
                        'width' => '300px', //'635px',
                        'linkedElement' => 'sub_button_text_shadow_b',
                        'sliderId' => 'sub_text-shadow-vertical-length-slider',
                        'sliderMin' => 0,
                        'sliderMax' => 25,
                        'sliderStep' => 1,
                        'admin_func' => 'otw_admin_slider',
                        'property' => 'sub_content_text_shadow|blur',
                        'config' => array(
                            'target' => 'sub_text_shadow',
                            'group' => 'sub_content_text_shadow',
                        ),
                    ),
                    'color' => array(
                        'enabled' => true,
                        'id' => 'sub_button_text_shadow_color',
                        'name' => 'sub_button_style[text-shadow][color]',
                        'label' => esc_html__('Text shadow color:', 'otw_bmp' ),
                        'description' => esc_html__('Set the color of the button text shadow', 'otw_bmp' ),
                        'property' => 'sub_content_text_shadow|color',
                        'admin_func' => 'otw_admin_color_picker',
                        'section' => '',
                        'data-target' => 'sub_text_shadow',
                        'data-group' => 'sub_content_text_shadow',
                        'config' => array(),
                    ),
                ),
            ),
        ),
    ),
    'link' => array(
        'title' => esc_html__('Link', 'otw_bmp' ),
        'elements' => array(
            'href' => array(
                'enabled' => true,
                'id' => 'button_href',
                'name' => 'button_href',
                'label' => esc_html__('URL:', 'otw_bmp' ),
                'description' => esc_html__('The URL for the button', 'otw_bmp' ),
                'property' => 'font-size',
                'admin_func' => 'otw_admin_text',
                'data-target' => 'href',
                'config' => array(
                ),
            ),
            'button_target' => array(
                'enabled' => true,
                'id' => 'button_target',
                'name' => 'button_target',
                'label' => esc_html__('Open link in new window:', 'otw_bmp' ),
                'description' => esc_html__('Where to be open the URL', 'otw_bmp' ),
                'property' => '',
                'admin_func' => 'otw_admin_drop_down',
                'data-target' => '',
                'config' => array(
                    'options' => $linkTargetOptions,
                ),
            ),
        ),
    ),
    'animation' => array(
        'title' => esc_html__('Animations', 'otw_bmp' ),
        'elements' => array(
            'animation_on_load_hover' => array(
                'enabled' => true,
                'id' => 'animation_on_load_hover',
                'name' => 'animation_on_load_hover',
                'label' => esc_html__('CSS animation activation', 'otw_bmp' ),
                'description' => esc_html__('Set an animation CSS activation', 'otw_bmp' ),
                'property' => 'class',
                'admin_func' => 'otw_admin_drop_down',
                'data-target' => 'animationClassOnLoad',
                'config' => array(
                    'options' => array(
                        'hover' => esc_html__('On hover (default)', 'otw_bmp' ),
                        'load' => esc_html__('On Load & Hover', 'otw_bmp' ),
                    ),
                ),
            ),
            'animation_button_class' => array(
                'enabled' => true,
                'id' => 'animation_button_class',
                'name' => 'animation_button_class',
                'label' => esc_html__('CSS animation Class', 'otw_bmp' ),
                'description' => esc_html__('Set an animation CSS class', 'otw_bmp' ),
                'property' => 'class',
                'admin_func' => 'otw_admin_drop_down',
                'data-target' => 'animationClass',
                'config' => array(
                    'options' => $otwAnimationsList,
                ),
            ),
        ),
    ),
    'box' => array(
        'title' => esc_html__('Box', 'otw_bmp' ),
        'elements' => array(
            'width' => array(
                'enabled' => true,
                'label' => esc_html__('Width:', 'otw_bmp' ),
                'description' => esc_html__('Set the width of the button', 'otw_bmp' ),
                'width' => '300px', //'635px',
                'linkedElement' => 'button_width',
                'sliderId' => 'width-slider',
                'sliderMin' => 0,
                'sliderMax' => 1000,
                'sliderStep' => 1,
                'property' => 'width',
                'admin_func' => 'otw_admin_slider',
                'config' => array(
                    'auto' => array(
                        'class' => 'auto',
                        'description' => esc_html__('auto', 'otw_bmp' ),
                        'data-id' => 'width',
                        'name' => 'width-auto',
                        'data-linked-object-id' => 'button_width',
                        'data-linked-slider-id' => 'width-slider',
                    ),
                ),
            ),
            'padding-top' => array(
                'enabled' => true,
                'id' => 'padding-top-slider',
                'label' => esc_html__('padding-top', 'otw_bmp' ),
                'width' => '300px', //'635px',
                'linkedElement' => 'button_padding_top',
                'sliderId' => 'padding-top-slider',
                'sliderMin' => 0,
                'sliderMax' => 200,
                'sliderStep' => 1,
                'property' => 'padding-top',
                'admin_func' => 'otw_admin_slider',
                'config' => array(),
            ),
            'padding-left' => array(
                'enabled' => true,
                'id' => 'padding-left-slider',
                'label' => esc_html__('padding-left', 'otw_bmp' ),
                'width' => '300px', //'635px',
                'linkedElement' => 'button_padding_left',
                'sliderId' => 'padding-left-slider',
                'sliderMin' => 0,
                'sliderMax' => 200,
                'sliderStep' => 1,
                'property' => 'padding-left',
                'admin_func' => 'otw_admin_slider',
                'config' => array(),
            ),
            'padding-right' => array(
                'enabled' => true,
                'id' => 'padding-right-slider',
                'label' => esc_html__('padding-right', 'otw_bmp' ),
                'width' => '300px', //'635px',
                'linkedElement' => 'button_padding_right',
                'sliderId' => 'padding-right-slider',
                'sliderMin' => 0,
                'sliderMax' => 200,
                'sliderStep' => 1,
                'property' => 'padding-right',
                'admin_func' => 'otw_admin_slider',
                'config' => array(),
            ),
            'padding-bottom' => array(
                'enabled' => true,
                'id' => 'padding-bottom-slider',
                'label' => esc_html__('padding-bottom', 'otw_bmp' ),
                'width' => '300px', //'635px',
                'linkedElement' => 'button_padding_bottom',
                'description' => esc_html__('Padding (top, right, bottom and left) is the INNER spacing of the button', 'otw_bmp' ),
                'sliderId' => 'padding-bottom-slider',
                'sliderMin' => 0,
                'sliderMax' => 200,
                'sliderStep' => 1,
                'property' => 'padding-bottom',
                'admin_func' => 'otw_admin_slider',
                'config' => array(),
            ),
            'margin-top' => array(
                'enabled' => true,
                'id' => 'margin-top-slider',
                'label' => esc_html__('margin-top', 'otw_bmp' ),
                'width' => '300px', //'635px',
                'linkedElement' => 'button_margin_top',
                'sliderId' => 'margin-top-slider',
                'sliderMin' => 0,
                'sliderMax' => 200,
                'sliderStep' => 1,
                'property' => 'margin-top',
                'admin_func' => 'otw_admin_slider',
                'section' => 'button_parent_style',
                'config' => array(
                    'target' => 'parentStylePx',
                ),
            ),
            'margin-left' => array(
                'enabled' => true,
                'id' => 'margin-left-slider',
                'label' => esc_html__('margin-left', 'otw_bmp' ),
                'width' => '300px', //'635px',
                'linkedElement' => 'button_margin_left',
                'sliderId' => 'margin-left-slider',
                'sliderMin' => 0,
                'sliderMax' => 200,
                'sliderStep' => 1,
                'property' => 'margin-left',
                'admin_func' => 'otw_admin_slider',
                'section' => 'button_parent_style',
                'config' => array(
                    'target' => 'parentStylePx',
                ),
            ),
            'margin-right' => array(
                'enabled' => true,
                'id' => 'margin-right-slider',
                'label' => esc_html__('margin-right', 'otw_bmp' ),
                'width' => '300px', //'635px',
                'linkedElement' => 'button_margin_right',
                'sliderId' => 'margin-right-slider',
                'sliderMin' => 0,
                'sliderMax' => 200,
                'sliderStep' => 1,
                'property' => 'margin-right',
                'admin_func' => 'otw_admin_slider',
                'section' => 'button_parent_style',
                'config' => array(
                    'target' => 'parentStylePx',
                ),
            ),
            'margin-bottom' => array(
                'enabled' => true,
                'id' => 'margin-bottom-slider',
                'label' => esc_html__('margin-bottom', 'otw_bmp' ),
                'description' => esc_html__('Margin (top, right, bottom and left) is the OUTER spacing of the button', 'otw_bmp' ),
                'width' => '300px', //'635px',
                'linkedElement' => 'button_margin_bottom',
                'sliderId' => 'margin-bottom-slider',
                'sliderMin' => 0,
                'sliderMax' => 200,
                'sliderStep' => 1,
                'property' => 'margin-bottom',
                'admin_func' => 'otw_admin_slider',
                'section' => 'button_parent_style',
                'config' => array(
                    'target' => 'parentStylePx',
                ),
            ),
            'box-shadow' => array(
                'enabled' => true,
                'grouped' => true,
                'id' => 'button_parent_style_box_shadow',
                'name' => 'button_parent_style[box-shadow]',
                'label' => esc_html__('Box shadow', 'otw_bmp' ),
                'description' => esc_html__('Box shadow', 'otw_bmp' ),
                'property' => 'box-shadow',
                'section' => 'button_parent_style',
                'children' => array(
                    'horizontal' => array(
                        'enabled' => true,
                        'name' => 'button_parent_style[box-shadow][horizontal]',
                        'label' => esc_html__('Box shadow horizontal length:', 'otw_bmp' ),
                        'description' => esc_html__('Box shadow horizontal length', 'otw_bmp' ),
                        'width' => '300px', //'635px',
                        'linkedElement' => 'button_box_shadow_h',
                        'sliderId' => 'box-shadow-horizontal-length-slider',
                        'sliderMin' => -20,
                        'sliderMax' => 20,
                        'sliderStep' => 1,
                        'admin_func' => 'otw_admin_slider',
                        'property' => 'content_box_shadow|horizontal',
                        'config' => array(
                            'target' => 'box_shadow',
                            'group' => 'content_box_shadow',
                        ),
                    ),
                    'vertical' => array(
                        'enabled' => true,
                        'name' => 'button_parent_style[box-shadow][vertical]',
                        'label' => esc_html__('Box shadow vertical length:', 'otw_bmp' ),
                        'description' => esc_html__('Box shadow vertical length', 'otw_bmp' ),
                        'width' => '300px', //'635px',
                        'linkedElement' => 'button_box_shadow_v',
                        'sliderId' => 'box-shadow-vertical-length-slider',
                        'sliderMin' => -20,
                        'sliderMax' => 20,
                        'sliderStep' => 1,
                        'admin_func' => 'otw_admin_slider',
                        'property' => 'content_box_shadow|vertical',
                        'config' => array(
                            'target' => 'box_shadow',
                            'group' => 'content_box_shadow',
                        ),
                    ),
                    'blur' => array(
                        'enabled' => true,
                        'name' => 'button_parent_style[box-shadow][blur]',
                        'label' => esc_html__('Box shadow blur radius:', 'otw_bmp' ),
                        'description' => esc_html__('Box shadow blur radius', 'otw_bmp' ),
                        'width' => '300px', //'635px',
                        'linkedElement' => 'button_box_shadow_b',
                        'sliderId' => 'box-shadow-vertical-length-slider',
                        'sliderMin' => 0,
                        'sliderMax' => 25,
                        'sliderStep' => 1,
                        'admin_func' => 'otw_admin_slider',
                        'property' => 'content_box_shadow|blur',
                        'config' => array(
                            'target' => 'box_shadow',
                            'group' => 'content_box_shadow',
                        ),
                    ),
                    'color' => array(
                        'enabled' => true,
                        'id' => 'button_box_shadow_color',
                        'name' => 'button_parent_style[box-shadow][color]',
                        'label' => esc_html__('Box shadow color:', 'otw_bmp' ),
                        'description' => esc_html__('Set the color of the button box shadow', 'otw_bmp' ),
                        'property' => 'content_box_shadow|color',
                        'admin_func' => 'otw_admin_color_picker',
                        'section' => '',
                        'data-target' => 'box_shadow',
                        'data-group' => 'content_box_shadow',
                        'config' => array(),
                    ),
                ),
            ),
        ),
    ),
    'border' => array(
        'title' => esc_html__('Border', 'otw_bmp' ),
        'elements' => array(
            'border-style' => array(
                'enabled' => true,
                'id' => 'button_border_style',
                'name' => 'button_style[border-style]',
                'label' => esc_html__('Border Style:', 'otw_bmp' ),
                'description' => esc_html__('Set the button border type', 'otw_bmp' ),
                'property' => 'border-style',
                'admin_func' => 'otw_admin_drop_down',
                'data-target' => 'style',
                'config' => array(
                    'options' => $borderStyleOptions,
                ),
                'section' => 'button_style',
            ),
            'border-color' => array(
                'enabled' => true,
                'id' => 'button_border_color',
                'name' => 'button_style[border-color]',
                'label' => esc_html__('border color:', 'otw_bmp' ),
                'description' => esc_html__('Set the color of the border of the button', 'otw_bmp' ),
                'property' => 'border-color',
                'admin_func' => 'otw_admin_color_picker',
                'data-target' => 'style',
                'section' => 'button_style',
            ),
            'border-width' => array(
                'enabled' => true,
                'id' => 'border-width-slider',
                'label' => esc_html__('border-width', 'otw_bmp' ),
                'description' => esc_html__('Set the width of the border', 'otw_bmp' ),
                'width' => '300px', //'635px',
                'linkedElement' => 'button_border_width',
                'sliderId' => 'border-width-slider',
                'sliderMin' => 0,
                'sliderMax' => 60,
                'sliderStep' => 1,
                'property' => 'border-width',
                'admin_func' => 'otw_admin_slider',
                'config' => array(),
            ),
            'border-radius' => array(
                'enabled' => true,
                'id' => 'border-radius-slider',
                'label' => esc_html__('border-radius', 'otw_bmp' ),
                'description' => esc_html__('Set button border radius', 'otw_bmp' ),
                'width' => '300px', //'635px',
                'linkedElement' => 'button_border_radius',
                'sliderId' => 'border-radius-slider',
                'sliderMin' => 0,
                'sliderMax' => 60,
                'sliderStep' => 1,
                'property' => 'border-radius',
                'admin_func' => 'otw_admin_slider',
                'config' => array(),
            ),
        ),
    ),
    'icon' => array(
        'title' => esc_html__('Icon', 'otw_bmp' ),
        'elements' => array(
            'icon' => array(
                'enabled' => true,
                'id' => 'button_icon',
                'name' => 'button_icon',
                'label' => esc_html__('Icon', 'otw_bmp' ),
                'description' => esc_html__('Choose an icon for the button', 'otw_bmp' ),
                'admin_func' => 'otw_admin_drop_down',
                'data-target' => 'icon',
                'property' => 'icon',
                'config' => array(
                    'class' => 'js-icons otw-form-text-input select2-wrapper',
                    'options' => $iconOptions,
                    'format' => 'select2',
                ),
            ),
            'icon-position' => array(
                'enabled' => true,
                'id' => 'button_icon_position',
                'name' => 'button_icon_position',
                'label' => esc_html__('Icon position:', 'otw_bmp' ),
                'description' => esc_html__('Set the icon position', 'otw_bmp' ),
                'property' => 'button_icon_position',
                'admin_func' => 'otw_admin_drop_down',
                'data-target' => 'iconPosition',
                'config' => array(
                    'options' => $positionOptions,
                ),
            ),
            'background-color' => array(
                'enabled' => true,
                'id' => 'button_icon-button_background_color',
                'name' => 'button_icon_box[background-color]',
                'label' => esc_html__('Icon box background color:', 'otw_bmp' ),
                'description' => esc_html__('Define the color for the button\'s background', 'otw_bmp' ),
                'property' => 'background-color',
                'admin_func' => 'otw_admin_color_picker',
                'data-target' => 'button_icon_box_styling',
                'data-group' => 'common',
                'section' => 'button_icon_box',
                'config' => array(
                    'target' => 'button_icon_box_styling',
                ),
            ),
            'border-style' => array(
                'enabled' => true,
                'id' => 'button_icon-button_border_style',
                'name' => 'button_icon_box[border-style]',
                'label' => esc_html__('Icon box border Style:', 'otw_bmp' ),
                'description' => esc_html__('Set the button border type', 'otw_bmp' ),
                'property' => 'border-style',
                'admin_func' => 'otw_admin_drop_down',
                'data-target' => 'button_icon_box_styling',
                'section' => 'button_icon_box',
                'config' => array(
                    'options' => $borderStyleOptions,
                    'target' => 'button_icon_box_styling',
                ),
            ),
            'border-color' => array(
                'enabled' => true,
                'id' => 'button_icon-button_border_color',
                'name' => 'button_icon_box[border-color]',
                'label' => esc_html__('Icon box border color:', 'otw_bmp' ),
                'description' => esc_html__('Set the color of the border of the button', 'otw_bmp' ),
                'property' => 'border-color',
                'admin_func' => 'otw_admin_color_picker',
                'data-target' => 'button_icon_box_styling',
                'section' => 'button_icon_box',
                'config' => array(
                    'target' => 'button_icon_box_styling',
                ),
            ),
            'border-width' => array(
                'enabled' => true,
                'id' => 'button_icon-border-width-slider',
                'label' => esc_html__('Icon box border-width', 'otw_bmp' ),
                'description' => esc_html__('Set the width of the border', 'otw_bmp' ),
                'width' => '300px', //'635px',
                'linkedElement' => 'button_icon-button_border_width',
                'sliderId' => 'button_icon-border-width-slider',
                'sliderMin' => 0,
                'sliderMax' => 60,
                'sliderStep' => 1,
                'property' => 'border-width',
                'admin_func' => 'otw_admin_slider',
                'section' => 'button_icon_box',
                'config' => array(
                    'target' => 'button_icon_box_styling',
                ),
            ),
            'border-radius' => array(
                'enabled' => true,
                'id' => 'button_icon-border-radius-slider',
                'label' => esc_html__('Icon box border-radius', 'otw_bmp' ),
                'description' => esc_html__('Set button border radius', 'otw_bmp' ),
                'width' => '300px', //'635px',
                'linkedElement' => 'button_icon-button_border_radius',
                'sliderId' => 'button_icon-border-radius-slider',
                'sliderMin' => 0,
                'sliderMax' => 60,
                'sliderStep' => 1,
                'property' => 'border-radius',
                'admin_func' => 'otw_admin_slider',
                'section' => 'button_icon_box',
                'config' => array(
                    'target' => 'button_icon_box_styling',
                ),
            ),
            'padding-top' => array(
                'enabled' => true,
                'id' => 'button_icon-padding-top-slider',
                'label' => esc_html__('Icon box padding-top', 'otw_bmp' ),
                'width' => '300px', //'635px',
                'linkedElement' => 'button_icon-button_padding_top',
                'sliderId' => 'button_icon-padding-top-slider',
                'sliderMin' => 0,
                'sliderMax' => 200,
                'sliderStep' => 1,
                'property' => 'padding-top',
                'admin_func' => 'otw_admin_slider',
                'section' => 'button_icon_box',
                'config' => array(
                    'target' => 'button_icon_box_styling',
                ),
            ),
            'padding-left' => array(
                'enabled' => true,
                'id' => 'button_icon-padding-left-slider',
                'label' => esc_html__('Icon box padding-left', 'otw_bmp' ),
                'width' => '300px', //'635px',
                'linkedElement' => 'button_icon-button_padding_left',
                'sliderId' => 'button_icon-padding-left-slider',
                'sliderMin' => 0,
                'sliderMax' => 200,
                'sliderStep' => 1,
                'property' => 'padding-left',
                'admin_func' => 'otw_admin_slider',
                'section' => 'button_icon_box',
                'config' => array(
                    'target' => 'button_icon_box_styling',
                ),
            ),
            'padding-right' => array(
                'enabled' => true,
                'id' => 'button_icon-padding-right-slider',
                'label' => esc_html__('Icon box padding-right', 'otw_bmp' ),
                'width' => '300px', //'635px',
                'linkedElement' => 'button_icon-button_padding_right',
                'sliderId' => 'button_icon-padding-right-slider',
                'sliderMin' => 0,
                'sliderMax' => 200,
                'sliderStep' => 1,
                'property' => 'padding-right',
                'admin_func' => 'otw_admin_slider',
                'section' => 'button_icon_box',
                'config' => array(
                    'target' => 'button_icon_box_styling',
                ),
            ),
            'padding-bottom' => array(
                'enabled' => true,
                'id' => 'button_icon-padding-bottom-slider',
                'label' => esc_html__('Icon box padding-bottom', 'otw_bmp' ),
                'width' => '300px', //'635px',
                'linkedElement' => 'button_icon-button_padding_bottom',
                'description' => esc_html__('Padding (top, right, bottom and left) is the INNER spacing of the button', 'otw_bmp' ),
                'sliderId' => 'button_icon-padding-bottom-slider',
                'sliderMin' => 0,
                'sliderMax' => 200,
                'sliderStep' => 1,
                'property' => 'padding-bottom',
                'admin_func' => 'otw_admin_slider',
                'section' => 'button_icon_box',
                'config' => array(
                    'target' => 'button_icon_box_styling',
                ),
            ),
            'margin-top' => array(
                'enabled' => true,
                'id' => 'button_icon-margin-top-slider',
                'label' => esc_html__('icon box margin-top', 'otw_bmp' ),
                'width' => '300px', //'635px',
                'linkedElement' => 'button_icon-button_margin_top',
                'sliderId' => 'button_icon-margin-top-slider',
                'sliderMin' => 0,
                'sliderMax' => 200,
                'sliderStep' => 1,
                'property' => 'margin-top',
                'admin_func' => 'otw_admin_slider',
                'section' => 'button_icon_box',
                'config' => array(
                    'target' => 'button_icon_box_styling',
                ),
            ),
            'margin-left' => array(
                'enabled' => true,
                'id' => 'button_icon-margin-left-slider',
                'label' => esc_html__('Icon box margin-left', 'otw_bmp' ),
                'width' => '300px', //'635px',
                'linkedElement' => 'button_icon-button_margin_left',
                'sliderId' => 'button_icon-margin-left-slider',
                'sliderMin' => 0,
                'sliderMax' => 200,
                'sliderStep' => 1,
                'property' => 'margin-left',
                'admin_func' => 'otw_admin_slider',
                'section' => 'button_icon_box',
                'config' => array(
                    'target' => 'button_icon_box_styling',
                ),
            ),
            'margin-right' => array(
                'enabled' => true,
                'id' => 'button_icon-margin-right-slider',
                'label' => esc_html__('Icon box margin-right', 'otw_bmp' ),
                'width' => '300px', //'635px',
                'linkedElement' => 'button_icon-button_margin_right',
                'sliderId' => 'button_icon-margin-right-slider',
                'sliderMin' => 0,
                'sliderMax' => 200,
                'sliderStep' => 1,
                'property' => 'margin-right',
                'admin_func' => 'otw_admin_slider',
                'section' => 'button_icon_box',
                'config' => array(
                    'target' => 'button_icon_box_styling',
                ),
            ),
            'margin-bottom' => array(
                'enabled' => true,
                'id' => 'button_icon-margin-bottom-slider',
                'label' => esc_html__('icon box margin-bottom', 'otw_bmp' ),
                'description' => esc_html__('Margin (top, right, bottom and left) is the OUTER spacing of the button', 'otw_bmp' ),
                'width' => '300px', //'635px',
                'linkedElement' => 'button_icon-button_margin_bottom',
                'sliderId' => 'button_icon-margin-bottom-slider',
                'sliderMin' => 0,
                'sliderMax' => 200,
                'sliderStep' => 1,
                'property' => 'margin-bottom',
                'admin_func' => 'otw_admin_slider',
                'section' => 'button_icon_box',
                'config' => array(
                    'target' => 'button_icon_box_styling',
                ),
            ),
        ),
    ),
    'background' => array(
        'title' => esc_html__('Background', 'otw_bmp' ),
        'elements' => array(
            'background-type' => array(
                'enabled' => true,
                'id' => 'button_background_type',
                'name' => 'button_background[background-type]',
                'label' => esc_html__('Type', 'otw_bmp' ),
                'description' => esc_html__('Define the type of the background', 'otw_bmp' ),
                'property' => 'background',
                'admin_func' => 'otw_admin_drop_down',
                'data-target' => 'background',
                'section' => 'button_background',
                'config' => array(
                    'options' => array(
                        'common' => esc_html__('Common', 'otw_bmp' ),
                        'linear-gradient' => esc_html__('Linear gradient', 'otw_bmp' ),
                        'radial-gradient' => esc_html__('Radial gradient', 'otw_bmp' ),
                    ),
                ),
            ),
            'background-start-color' => array(
                'enabled' => true,
                'id' => 'button_background_start_color',
                'name' => 'button_background[background-start-color]',
                'label' => esc_html__('Background start color:', 'otw_bmp' ),
                'description' => esc_html__('Define the start color for the button\'s background', 'otw_bmp' ),
                'property' => 'background-start-color',
                'admin_func' => 'otw_admin_color_picker',
                'data-target' => 'background',
                'data-group' => 'gradient',
                'section' => 'button_background',
            ),
            'background-end-color' => array(
                'enabled' => true,
                'id' => 'button_background_end_color',
                'name' => 'button_background[background-end-color]',
                'label' => esc_html__('Background end color:', 'otw_bmp' ),
                'description' => esc_html__('Define the end color for the button\'s background', 'otw_bmp' ),
                'property' => 'background-end-color',
                'admin_func' => 'otw_admin_color_picker',
                'data-target' => 'background',
                'data-group' => 'gradient',
                'section' => 'button_background',
            ),
            'background-reach-from' => array(
                'enabled' => true,
                'id' => 'button_reach_from',
                'name' => 'button_background[background-reach-from]',
                'label' => esc_html__('Reach from:', 'otw_bmp' ),
                'description' => esc_html__('Set the reach from', 'otw_bmp' ),
                'width' => '300px', //'635px',
                'linkedElement' => 'button_reach_from',
                'sliderId' => 'reach-from-slider',
                'sliderMin' => 0,
                'sliderMax' => 100,
                'sliderStep' => 1,
                'property' => 'background-reach-from',
                'admin_func' => 'otw_admin_slider',
                'data-target' => 'background',
                'section' => 'button_background',
                'config' => array(
                    'target' => 'background',
                    'group' => 'gradient',
                    'measures' => '%',
                ),
            ),
            'background-reach-to' => array(
                'enabled' => true,
                'id' => 'button_background_end_reach',
                'name' => 'button_background[background-reach-to]',
                'label' => esc_html__('Reach to:', 'otw_bmp' ),
                'description' => esc_html__('Set the reach to', 'otw_bmp' ),
                'width' => '300px', //'635px',
                'linkedElement' => 'button_reach_to',
                'sliderId' => 'reach-to-slider',
                'sliderMin' => 0,
                'sliderMax' => 100,
                'sliderStep' => 1,
                'property' => 'reach-to',
                'admin_func' => 'otw_admin_slider',
                'data-target' => 'background',
                'section' => 'button_background',
                'config' => array(
                    'target' => 'background',
                    'group' => 'gradient',
                    'measures' => '%',
                ),
            ),
            'background-angle' => array(
                'enabled' => true,
                'id' => 'button_background_angle',
                'name' => 'button_background[background-angle]',
                'label' => esc_html__('Angle:', 'otw_bmp' ),
                'description' => esc_html__('Set the angle', 'otw_bmp' ),
                'width' => '300px', //'635px',
                'linkedElement' => 'button_angle',
                'sliderId' => 'angle-slider',
                'sliderMin' => 0,
                'sliderMax' => 360,
                'sliderStep' => 1,
                'property' => 'angle',
                'admin_func' => 'otw_admin_slider',
                'data-target' => 'background',
                'section' => 'button_background',
                'config' => array(
                    'target' => 'background',
                    'group' => 'linear-gradient',
                    'measures' => 'deg',
                ),
            ),
            'background-color' => array(
                'enabled' => true,
                'id' => 'button_background_color',
                'name' => 'button_background[background-color]',
                'label' => esc_html__('Background color:', 'otw_bmp' ),
                'description' => esc_html__('Define the color for the button\'s background', 'otw_bmp' ),
                'property' => 'background-color',
                'admin_func' => 'otw_admin_color_picker',
                'data-target' => 'background',
                'data-group' => 'common',
                'section' => 'button_background',
            ),
        ),
    ),
    'hover' => array(
        'title' => esc_html__('Hover', 'otw_bmp' ),
        'elements' => array(
            'background-color' => array(
                'enabled' => true,
                'id' => 'button_hover_background_color',
                'name' => 'button_hover_style[background-color]',
                'label' => esc_html__('Background color:', 'otw_bmp' ),
                'description' => esc_html__('Define the color for the button\'s background when hover', 'otw_bmp' ),
                'property' => 'background-color',
                'admin_func' => 'otw_admin_color_picker',
                'data-target' => 'hover_style',
                'section' => 'button_hover_style',
            ),
            'sub-color' => array(
                'enabled' => true,
                'id' => 'button_hover_color_sub',
                'name' => 'sub_button_hover_style[color]',
                'label' => esc_html__('Sub text Color:', 'otw_bmp' ),
                'description' => esc_html__('Set the button text color when hover', 'otw_bmp' ),
                'property' => 'color',
                'admin_func' => 'otw_admin_color_picker',
                'data-target' => 'sub_hover_style',
                'section' => 'sub_button_hover_style',
            ),
            'color' => array(
                'enabled' => true,
                'id' => 'button_hover_color_content',
                'name' => 'button_hover_style[color]',
                'label' => esc_html__('Text Color:', 'otw_bmp' ),
                'description' => esc_html__('Set the button text color when hover', 'otw_bmp' ),
                'property' => 'color',
                'admin_func' => 'otw_admin_color_picker',
                'data-target' => 'hover_style',
                'section' => 'button_hover_style',
            ),
            'border-color' => array(
                'enabled' => true,
                'id' => 'button_hover_border_color',
                'name' => 'button_hover_style[border-color]',
                'label' => esc_html__('Border color:', 'otw_bmp' ),
                'description' => esc_html__('Define the color for the button\'s border when hover', 'otw_bmp' ),
                'property' => 'border-color',
                'admin_func' => 'otw_admin_color_picker',
                'data-target' => 'hover_style',
                'section' => 'button_hover_style',
            ),
            'upper-color' => array(
                'enabled' => true,
                'id' => 'button_hover_color_upper',
                'name' => 'upper_button_hover_style[color]',
                'label' => esc_html__('Upper text Color:', 'otw_bmp' ),
                'description' => esc_html__('Set the button text color when hover', 'otw_bmp' ),
                'property' => 'color',
                'admin_func' => 'otw_admin_color_picker',
                'data-target' => 'upper_hover_style',
                'section' => 'upper_button_hover_style',
            ),
            'opacity' => array(
                'enabled' => true,
                'id' => 'opacity-slider',
                'label' => esc_html__('Opacity', 'otw_bmp' ),
                'description' => esc_html__('Set the Opacity of the button when hover', 'otw_bmp' ),
                'width' => '300px', //'635px',
                'linkedElement' => 'button_hover_style_opacity',
                'sliderId' => 'opacity-slider',
                'sliderMin' => 0,
                'sliderMax' => 1,
                'sliderStep' => 0.1,
                'property' => 'opacity',
                'admin_func' => 'otw_admin_slider',
                'data-target' => 'hover_style',
                'config' => array(
                    'target' => 'hover_style',
                    'measures' => '',
                ),
                'section' => 'button_hover_style',
            ),
        ),
    ),
    'custom_options' => array(
        'title' => esc_html__('Custom Options', 'otw_bmp' ),
        'elements' => array(
            'icon_url' => array(
                'enabled' => true,
                'id' => 'icon_url',
                'name' => 'icon_url',
                'label' => esc_html__('Icon URL (upload icon)', 'otw_bmp' ),
                'description' => esc_html__('Choose a custom icon URL. Available formats - "gif", "jpeg", "jpg", "png", "wbmp"', 'otw_bmp' ),
                'property' => 'class',
                'admin_func' => 'otw_admin_uploader',
                'data-target' => 'icon_url',
                'config' => array(),
            ),
            'button_class' => array(
                'enabled' => true,
                'id' => 'button_class',
                'name' => 'button_class',
                'label' => esc_html__('CSS Class', 'otw_bmp' ),
                'description' => esc_html__('Set an additional CSS class name.<br />This class name can be used for styling. ', 'otw_bmp' ),
                'property' => 'class',
                'admin_func' => 'otw_admin_text',
                'data-target' => 'class',
                'config' => array(),
            ),
            'button_custom_style' => array(
                'enabled' => true,
                'id' => 'button_custom_style',
                'name' => 'button_custom_style',
                'label' => esc_html__('Custom style', 'otw_bmp' ),
                'description' => esc_html__('Choose custom style', 'otw_bmp' ),
                'property' => 'class',
                'admin_func' => 'otw_admin_drop_down',
                'data-target' => 'selectClass',
                'config' => array(
                    'options' => 'custom_style_option',
                ),
                'section' => 'button_style',
            ),
        ),
    ),
);

// @todo find a better way
$buttonSections = array(
    'button-builder' => array(
        'link' => array('href', 'button_target'),
        'font_text' => array('title', 'font-family', 'font-weight', 'font-style', 'text-transform', 'color', 'font-size', 'text-shadow'),
        'sub_font_text' => array('sub-title', 'font-family', 'font-weight', 'font-style', 'text-transform', 'color', 'font-size', 'text-shadow'),
        'animation' => array('animation_on_load_hover', 'animation_button_class'),
        'box' => array('width', 'padding-top', 'padding-right', 'padding-bottom', 'padding-left', 'margin-top', 'margin-right', 'margin-bottom', 'margin-left', 'box-shadow'),
        'border' => array('border-style', 'border-color', 'border-width', 'border-radius'),
        'icon' => array('icon', 'icon-position', 'background-color', 'border-style', 'border-color', 'border-width', 'border-radius', 'padding-top', 'padding-right', 'padding-bottom', 'padding-left', 'margin-top', 'margin-right', 'margin-bottom', 'margin-left'),
        'custom_options' => array('icon_url', 'button_class'),
        'background' => array('background-type', 'background-start-color', 'background-end-color', 'background-color', 'background-reach-from', 'background-reach-to', 'background-angle'),
        'hover' => array('background-color', 'sub-color', 'color', 'border-color', 'opacity'),
    ),
    'download-button' => array(
        'link' => array('href', 'button_target'),
        'upper_font_text' => array('upper-title', 'font-family', 'font-weight', 'font-style', 'text-transform', 'color', 'font-size', 'text-shadow', 'text-align', 'background-color'),
        'font_text' => array('title', 'font-family', 'font-weight', 'font-style', 'text-transform', 'color', 'font-size', 'text-shadow'),
        'sub_font_text' => array('sub-title', 'font-family', 'font-weight', 'font-style', 'text-transform', 'color', 'font-size', 'text-shadow', 'text-align', 'background-color'),
        'animation' => array('animation_on_load_hover', 'animation_button_class'),
        'box' => array('width', 'padding-top', 'padding-right', 'padding-bottom', 'padding-left', 'margin-top', 'margin-right', 'margin-bottom', 'margin-left', 'box-shadow'),
        'border' => array('border-style', 'border-color', 'border-width', 'border-radius'),
        'icon' => array('icon', 'icon-position', 'background-color', 'border-style', 'border-color', 'border-width', 'border-radius', 'padding-top', 'padding-right', 'padding-bottom', 'padding-left', 'margin-top', 'margin-right', 'margin-bottom', 'margin-left'),
        'custom_options' => array('icon_url', 'button_class'),
        'background' => array('background-type', 'background-start-color', 'background-end-color', 'background-color', 'background-reach-from', 'background-reach-to', 'background-angle'),
        'hover' => array('background-color', 'sub-color', 'color', 'border-color', 'upper-color', 'opacity'),
    ),
);

$config = array(
    'button_name' => array(),
    'button_title' => array(),
    'button_class' => array(),
    'button_icon' => array(),
    'button_parent_class' => array(),
);