<?php global $otw_bmp_name, $buttonTypes, $chosenButtonType, $otwPluginDevName, $content; ?>
<div class="wrap">
    <div id="icon-edit" class="icon32"></div>
    <a class="add-new-h2"
       href="admin.php?page=<?php echo $otw_bmp_name; ?>-list">
        <?php esc_html_e('Back', 'otw_bmp' ); ?>
    </a>
    <?php
    if (!empty(otw_get( 'success', '' )) && otw_get( 'success', '' ) == 'true') {
        $message = esc_html__('Item was saved.', 'otw_bmp' );
        echo '<div class="updated"><p>' . $message . '</p></div>';
    }
    ?>
    <form name="otw-bm-list" method="post" action="" class="validate">
        <input type="hidden" name="edit" value="<?php echo esc_attr( $edit ); ?>"/>
        <input type="hidden" name="<?php echo $otwPluginDevName; ?>_action"
               value="manage_<?php echo esc_attr( $otwPluginDevName ) ?>"/>
        <?php
        if (!empty($errors)) {
            $errorMsg = esc_html__('Oops! Please check form for errors.', 'otw_bmp' );
            echo '<div class="error"><p>' . $errorMsg . '</p></div>';
        }
        ?>
        <table class="form-table">
            <tbody>
            <tr valign="top">
                <th class="label-col" scope="row">
                    <label for="button_name" class="required">
                        <?php esc_html_e('Button Name', 'otw_bmp' ); ?>
                    </label>
                </th>
                <td class="element-col">
                    <?php
                    echo OTW_Form::text_input(array(
                        'id' => 'button_name',
                        'name' => 'button_name',
                        'required' => true,
                        'value' => $content['button_name'],
                        'description' => esc_html__('Note: The Button Name is going to be used ONLY for the admin as a reference.', 'otw_bmp' ),
                    ));
                    ?>
                    <div class="inline-error">
                        <?php
                        (!empty($errors['button_name'])) ? $errorMessage = $errors['button_name'] : $errorMessage = '';
                        echo $errorMessage;
                        ?>
                    </div>
                </td>
            </tr>
            <tr valign="top">
                <th class="label-col" scope="row">
                    <label for="button_name" class="required">
                        <?php esc_html_e('Button Type', 'otw_bmp' ); ?>
                    </label>
                </th>
                <td class="element-col">
                    <?php
                    if ($edit === false) {
                        $options = array('' => '---');
                        foreach ($buttonTypes as $buttonType => $buttonData) {
                            $options[$buttonType] = $buttonData['title'];
                        }
                        echo OTW_Form::select(array(
                            'id' => $otwPluginDevName . '_type',
                            'name' => 'type',
                            'parse' => $content,
                            'options' => $options,
                            'autocomplete' => 'off',
                        ));
                    } else {?>
                	<input type="hidden" name="type" value="<?php echo esc_attr( $content['type'] );?>" />
                	<?php
                        echo $buttonTypes[$content['type']]['title'];
                    }
                    ?>
                    <div class="inline-error">
                        <?php
                        (!empty($errors['type'])) ? $errorMessage = $errors['type'] : $errorMessage = '';
                        echo $errorMessage;
                        ?>
                    </div>
                </td>
            </tr>
            <tr>
                <th></th>
                <td>
                    <div class="inline-error">
                        <?php
                        (!empty($errors['content'])) ? $errorMessage = $errors['content'] : $errorMessage = '';
                        echo $errorMessage;
                        ?>
                    </div>
                </td>
            </tr>
            </tbody>
        </table>
        <div id="ajax-content" class="otw-settings-preview-holder">
            <?php
            if (!empty($chosenButtonType)) {
                OTW_Shortcode_OTW_BMP::build_admin_form($chosenButtonType);
            }
            ?>
        </div>
        <p class="submit">
            <input type="submit"
                   value="<?php esc_html_e('Save', 'otw_bmp' ) ?>"
                   name="submit-<?php echo $otw_bmp_name; ?>"
                   class="button button-primary button-hero"/>
        </p>
    </form>
</div>