<?php
global $otw_bmp_name, $otwPluginDevName, $chosenButtonType, $otw_bmp_list, $shortcodeName;
$_wp_column_headers['toplevel_page_' . $otw_bmp_name] = array(
    'button_name' => esc_html__('Button Name', 'otw_bmp' ),
    'shortcode' => esc_html__('Short Code', 'otw_bmp' ),
    'type' => esc_html__('Button Type', 'otw_bmp' ),
    'user_id' => esc_html__('Author', 'otw_bmp' ),
    'date_created' => esc_html__('Created', 'otw_bmp' ),
    'date_modified' => esc_html__('Modified', 'otw_bmp' ),
);

$message = '';
$massages = array();
$messages[1] = esc_html__('Button saved.', 'otw_bmp' );
$messages[2] = esc_html__('Button deleted.', 'otw_bmp' );
$messages[5] = esc_html__('Button copied.', 'otw_bmp' );
$messages[6] = esc_html__('Please select button type.', 'otw_bmp' );

if ( otw_get( 'message', false )  && isset($messages[otw_get( 'message', '' )])) {
    $message .= $messages[otw_get( 'message', '' )];
}
?>
<?php if ($message) : ?>
    <div id="message" class="updated"><p><?php echo esc_html( $message ); ?></p></div>
<?php endif; ?>
<div class="wrap">
    <div id="icon-edit" class="icon32"></div>
    <h2>
        <?php esc_html_e('Buttons', 'otw_bmp' ); ?>
        <a class="add-new-h2" href="admin.php?page=otw-bmp-add"><?php esc_html_e('Add Button', 'otw_bmp' );?></a>
    </h2>

    <?php
    if (!empty($action['success']) && $action['success'] == 'true') {
        $message = esc_html__('Item was saved.', 'otw_bmp' );
        echo '<div class="updated"><p>' . $message . '</p></div>';
    }

    if (!empty($action['success_css']) && $action['success_css'] == 'true') {
        $message = esc_html__('Custom CSS file has been updated.', 'otw_bmp' );
        echo '<div class="updated"><p>' . $message . '</p></div>';
    }

    if (!isset($writableError)) {
        $writableError = false;
    }
    if ($writableError) {
        $message = esc_html__('The folder \'wp-content/uploads/\' is not writable. Please make sure you add read/write permissions to this folder.', 'otw_bmp' );
        echo '<div class="error"><p>' . $message . '</p></div>';
    }

    if (!isset($writableCssError)) {
        $writableCssError = false;
    }
    if ($writableCssError) {
        if (!defined('SKIN_BM_PATH')) {
            define('SKIN_BM_PATH', 'tmp');
        }
        $message = esc_html__('The file \'' . SKIN_BM_PATH . '\' is not writable. Please make sure you add read/write permissions to this file.', 'otw_bmp' );
        echo '<div class="error"><p>' . $message . '</p></div>';
    }

    if (!empty($otw_bmp_list)) {
        ?>

        <table class="widefat fixed" cellspacing="0">
            <thead>
            <tr>
                <?php foreach ($_wp_column_headers['toplevel_page_' . $otw_bmp_name] as $key => $name) { ?>
                    <th><?php echo esc_html( $name ) ?></th>
                <?php } ?>
            </tr>
            </thead>
            <tfoot>
            <tr>
                <?php foreach ($_wp_column_headers['toplevel_page_' . $otw_bmp_name] as $key => $name) { ?>
                    <th><?php echo esc_html( $name ) ?></th>
                <?php } ?>
            </tr>
            </tfoot>
            <tbody>
            <?php
            $index = 0;
            foreach ($otw_bmp_list as $bmpId => $otw_bmp_item) {
                if (is_array($otw_bmp_item)) {
                    $user_info = get_userdata($otw_bmp_item['user_id']);

                    //Used to add color to even rows
                    $alternate = '';
                    if ($index % 2 == 0) {
                        $alternate = 'class="alternate"';
                    }

                    $edit_link = admin_url('admin.php?page=' . $otw_bmp_name . '-add&amp;button-type=' . $otw_bmp_item['type'] . '&amp;action=edit&amp;' . $otw_bmp_name . '-id=' . $otw_bmp_item['id']);
                    $delete_link = admin_url('admin.php?page=' . $otw_bmp_name . '-list&amp;button-type=' . $otw_bmp_item['type'] . '&amp;action=delete&amp;' . $otw_bmp_name . '-id=' . $otw_bmp_item['id']);
                    $copy_link = admin_url('admin.php?page=' . $otw_bmp_name . '-list&amp;button-type=' . $otw_bmp_item['type'] . '&amp;action=copy&amp;' . $otw_bmp_name . '-id=' . $otw_bmp_item['id']);
                    ?>
                    <tr <?php echo $alternate; ?> >
                        <td>
                            <?php echo '<a href="' . $edit_link . '">' . $otw_bmp_item['button_name'] . '</a>'; ?>
                            <div class="row-actions">
                                <?php
                                echo '<a href="' . $edit_link . '">' . esc_html__('Edit', 'otw_bmp' ) . '</a>';
                                echo ' | <a href="' . $delete_link . '" data-name="' . $otw_bmp_item['button_name'] . '" class="js-delete-item">' . esc_html__('Delete', 'otw_bmp' ) . '</a>';
                                echo ' | <a href="' . $copy_link . '" data-name="' . $otw_bmp_item['button_name'] . '" class="js-duplicate-item">' . esc_html__('Duplicate', 'otw_bmp' ) . '</a>';
                                ?>
                            </div>
                        </td>
                        <td><?php echo '[' . $shortcodeName . ' id="' . $otw_bmp_item['id'] . '"]'; ?></td>
                        <td><?php esc_html_e($otw_bmp_item['type'], $otwPluginDevName); ?></td>
                        <td><?php echo esc_html( $user_info->display_name ); ?></td>
                        <td><?php echo esc_html( $otw_bmp_item['date_created'] ); ?></td>
                        <td><?php echo esc_html( $otw_bmp_item['date_modified'] ); ?></td>
                    </tr>
                    <?php
                    $index++;
                }
            }
            ?>
            </tbody>
        </table>
    <?php } else { ?>
        <p>
            <strong><?php esc_html_e('No buttons found.', 'otw_bmp' ) ?></strong>
        </p>
    <?php } ?>
</div>
